//
//  ZGHUDHelper.h
//  ZIMExampleLegacy (iOS)
//
//  Created by Patrick Fu on 2021/6/26.
//  Copyright © 2021 Zego. All rights reserved.
//

#import <UIKit/UIKit.h>

@interface ZGHUDHelper : NSObject

/// Display a message
/// @param message message content
+ (void)showMessage:(NSString *)message;

/// Display a message
/// @param message message content
/// @param doneHandler done callback
+ (void)showMessage:(NSString *)message done:(void(^)(void))doneHandler;

/// Show prompt task in progress message
/// @param message message content
/// @param doneHandler done callback
+ (void)showIndeterminateMessage:(NSString *)message done:(void(^)(void))doneHandler;

/// Show prompts for custom Views and messages
/// @param message message content
/// @param customView custom view
/// @param doneHandler done callback
+ (void)showCustomMessage:(NSString *)message customView:(UIView *)customView done:(void(^)(void))doneHandler;

/// Display network loading HUD
+ (void)showNetworkLoading;

/// Remove network loading HUD
+ (void)hideNetworkLoading;

@end
