//
//  GlobalMessageSearchedListViewController.m
//  ZIMExampleDemo
//
//  Created by lizhanpeng on 2023/6/29.
//

#import "GlobalMessageSearchedListViewController.h"
#import "ConversationSearchTableViewCell.h"
@interface GlobalMessageSearchedListViewController()


@end

@implementation GlobalMessageSearchedListViewController

- (instancetype)init
{
    self = [super init];
    if (self) {
        self.searchInInfoList = [[NSArray alloc] init];
    }
    return self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    
    // 设置UITableView的数据源和代理为当前视图控制器
    self.tableView.dataSource = self;
    self.tableView.delegate = self;
}

#pragma mark - UITableViewDataSource

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    // 返回表格的行数
    return self.searchInInfoList.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    ConversationSearchTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"ConversationSearchTableViewCell"];
    cell.searchInfo = self.searchInInfoList[indexPath.row];
    [cell.conversationTitleLabel setText:[NSString stringWithFormat:@"会话 ID: %@",self.searchInInfoList[indexPath.row].conversationID]];
    [cell.conversationContentLabel setText:[NSString stringWithFormat:@"相关消息条数: %d 条",self.searchInInfoList[indexPath.row].totalMessageCount]];
    // 设置每行的内容
    
    return cell;
}

#pragma mark - UITableViewDelegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // 处理选中行的操作
    NSLog(@"选中了第%ld行", (long)indexPath.row + 1);
}

//- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
//    // 返回每行的高度
//    return 44;
//}
//
//- (void)scrollViewDidScroll:(UIScrollView *)scrollView {
//    // 处理滚动视图的滚动事件
//    NSLog(@"滚动位置：%@", NSStringFromCGPoint(scrollView.contentOffset));
//}

@end
