//
//  CreateGroupModel.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/1/21.
//

#import "CreateGroupModel.h"

@protocol groupMemberListDelegate;

@interface CreateGroupModel()
@property (nonatomic, strong) NSHashTable<id<groupMemberListDelegate>> *groupMemberListDelegates;
@end

@implementation CreateGroupModel


- (instancetype)init
{
    self = [super init];
    if (self) {
        self.createGroupMemberList = [[NSMutableArray alloc] init];
        self.groupMemberListDelegates = [NSHashTable weakObjectsHashTable];
        
    }
    return self;
}

- (void)addGroupMemberListDelegate:(id<groupMemberListDelegate>)delegate{
    [self.groupMemberListDelegates addObject:delegate];
}


-(void)addGroupMemberList:(nonnull NSString *)groupMemberID{
    bool isRepetition = false;
   
    for (NSString *memberID in self.createGroupMemberList) {
        if([memberID isEqual:groupMemberID]){
            isRepetition = true;
        }
    }
    if(isRepetition == false){
        [self.createGroupMemberList addObject:groupMemberID];
        [self noticeGroupMemberList];
    }
    
}

-(void)deleteGroupMemberList:(NSString *)groupMemberID{
    int index = 0 ;
    for (int i = 0; i<self.createGroupMemberList.count; i++) {
        if([self.createGroupMemberList[i] isEqual:groupMemberID]){
            index = i;
        }
    }
    [self.createGroupMemberList removeObjectAtIndex:index];
    [self noticeGroupMemberList];
}


-(void)noticeGroupMemberList{
    dispatch_async(dispatch_get_main_queue(), ^{
        for (id<groupMemberListDelegate> delegate in self.groupMemberListDelegates) {
            if ([delegate respondsToSelector:@selector(groupMemberListupdate:)]) {
                [delegate groupMemberListupdate:self.createGroupMemberList];
            }
        }
    });
}

@end


