//
//  GroupReceiveMsgImage.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/4/25.
//

#import "GroupReceiveMsgImage.h"
#import "ZGZIMManager.h"


@implementation GroupReceiveMsgImage

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

-(void)readyToshow:(ZIMImageMessage *)imgMsg
          callback:(void(^)(ZIMMessage * msg))callbackMsg{
    self.msgStatusImageView.hidden = true;
    [self.titleLabel setText:imgMsg.senderUserID];
    if(imgMsg.receiptStatus == ZIMMessageReceiptStatusProcessing){
        [self.msgStatusImageView setImage:[UIImage imageNamed:@"duigou"]];
        self.msgStatusImageView.hidden = false;
    }else if(imgMsg.receiptStatus == ZIMMessageReceiptStatusDone){
        [self.msgStatusImageView setImage:[UIImage imageNamed:@"duigou-xuanzhong"]];
        self.msgStatusImageView.hidden = false;
    }else{
        self.msgStatusImageView.hidden = true;
    }
    NSData *imageData = [NSData dataWithContentsOfFile:imgMsg.fileLocalPath];
    if(imageData == nil){
        imageData = [NSData dataWithContentsOfFile:imgMsg.thumbnailLocalPath];
    }
    if(imageData == nil){
        [[ZGZIMManager shared] downloadMediaFileWithMessage:imgMsg fileType:ZIMMediaFileTypeThumbnail progress:^(ZIMMessage * _Nonnull message, unsigned long long currentFileSize, unsigned long long totalFileSize) {
            self.progressView.hidden = false;
            float progress = [NSString stringWithFormat:@"%.1f",(float)currentFileSize/(float)totalFileSize].floatValue;
            [self.progressView setProgress:progress animated:YES];
        } callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
            self.progressView.hidden = true;
            if(errorInfo.code == 0){
                NSData *data = [NSData dataWithContentsOfFile:((ZIMImageMessage *)message).thumbnailLocalPath];
                if(data != nil){
                    [self.photoimage setImage:[UIImage imageWithData:data]];
                }
            }else{
                self.msgStatusImageView.hidden = false;
            }
        }];
        self.progressView.progress = 0.0;
        [self.photoimage setImage:[UIImage imageNamed:@"photo"]];
    }
    if(imageData != nil){
        [self.photoimage setImage:[UIImage imageWithData:imageData]];
    }
}

@end
