//
//  GroupSendMsgFileTableViewCell.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/4/27.
//

#import "GroupSendMsgFileTableViewCell.h"
#import "ZGZIMManager.h"

@implementation GroupSendMsgFileTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    
    // Initialization code
}
- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];
    
    // Configure the view for the selected state
}



-(void)readyToshow:(ZIMMessage *)message
          callback:(void(^)(MessageCellEvent event,ZIMMessage * msg))callback{
    [super readyToshow:message callback:callback];
    switch (message.sentStatus) {
        case ZIMMessageSentStatusSendFailed:
            [self.msgStatusImageView setImage:[UIImage imageNamed:@"gantanhao-2"]];
            self.msgStatusImageView.hidden = false;
            break;
        case ZIMMessageSentStatusSending:{
            self.msgStatusImageView.hidden = true;
            break;
        }
        case ZIMMessageSentStatusSendSuccess:{
            if(message.receiptStatus == ZIMMessageReceiptStatusProcessing){
                [self.msgStatusImageView setImage:[UIImage imageNamed:@"duigou"]];
                self.msgStatusImageView.hidden = false;
            }else if(message.receiptStatus == ZIMMessageReceiptStatusDone){
                [self.msgStatusImageView setImage:[UIImage imageNamed:@"duigou-xuanzhong"]];
                self.msgStatusImageView.hidden = false;
            }else{
                self.msgStatusImageView.hidden = true;
            }
            break;
        }
        default:
            break;
    }
    [self.titleLabel setText:[ZGZIMManager shared].myUserID];
    ZIMFileMessage *fileMsg = (ZIMFileMessage *)message;
    if(fileMsg.sentStatus == 3){
        self.fileNameLabel.hidden = true;
        [fileMsg setValue:[NSNumber numberWithInt:0] forKey:@"sentStatus"];
        [[ZGZIMManager shared] sendMediaMessage:fileMsg toConversationID:self.masterVC.toGroupID conversationType:ZIMConversationTypeGroup config:_sendConfig progress:^(ZIMMessage * _Nonnull message, unsigned long long currentFileSize, unsigned long long totalFileSize) {
            self.progressView.hidden = false;
            float progress = [NSString stringWithFormat:@"%.1f",(float)currentFileSize/(float)totalFileSize].floatValue;
            [self.progressView setProgress:progress animated:YES];
        } callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
            self.progressView.hidden = true;
            self.fileNameLabel.hidden = false;
            [self.fileNameLabel setText:((ZIMFileMessage *)message).fileName];
            callback(Update,message);
        }];
        callback(Update,fileMsg);
    }
    else if(fileMsg.sentStatus == ZIMMessageSentStatusSending){
        
       
    }
    else{
        self.fileNameLabel.hidden = false;
        [self.fileNameLabel setText:fileMsg.fileName];
    }
}
@end
