//
//  GroupSendMsgImageTableViewCell.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/4/26.
//

#import "GroupSendMsgImageTableViewCell.h"
#import "ZGZIMManager.h"

@implementation GroupSendMsgImageTableViewCell


- (void)awakeFromNib {
    [super awakeFromNib];
    
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];
    
    // Configure the view for the selected state
    
    
}


-(void)readyToshow:(ZIMMessage *)message
          callback:(void(^)(MessageCellEvent event,ZIMMessage * msg))callback{
    [super readyToshow:message callback:callback];
    self.msgStatusImageView.hidden = true;
    [self.titleLabel setText:[ZGZIMManager shared].myUserID];
    ZIMImageMessage *imgMsg = (ZIMImageMessage *)message;
    if(imgMsg.receiptStatus == ZIMMessageReceiptStatusProcessing){
        [self.msgStatusImageView setImage:[UIImage imageNamed:@"duigou"]];
        self.msgStatusImageView.hidden = false;
    }else if(imgMsg.receiptStatus == ZIMMessageReceiptStatusDone){
        [self.msgStatusImageView setImage:[UIImage imageNamed:@"duigou-xuanzhong"]];
        self.msgStatusImageView.hidden = false;
    }else{
        self.msgStatusImageView.hidden = true;
    }
    if(imgMsg.sentStatus == 3){
        [self.sendImage setImage:[UIImage imageWithData:[NSData dataWithContentsOfFile:imgMsg.fileLocalPath]]];
        [imgMsg setValue:[NSNumber numberWithInt:0] forKey:@"sentStatus"];
        [[ZGZIMManager shared] sendMediaMessage:imgMsg toConversationID:self.masterVC.toGroupID conversationType:ZIMConversationTypeGroup config:_sendConfig progress:^(ZIMMessage * _Nonnull message, unsigned long long currentFileSize, unsigned long long totalFileSize) {
            self.progressView.hidden = false;
            float progress = [NSString stringWithFormat:@"%.1f",(float)currentFileSize/(float)totalFileSize].floatValue;
            [self.progressView setProgress:progress animated:YES];
        } callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
            self.progressView.hidden = true;
            callback(Update,message);
            if(errorInfo.code == 0){
                
            }else{
                self.msgStatusImageView.hidden = false;
            }
            
        }];
        callback(Update,imgMsg);
    }
    if(imgMsg.sentStatus == ZIMMessageSentStatusSending){
        [self.sendImage setImage:[UIImage imageWithData:[NSData dataWithContentsOfFile:imgMsg.fileLocalPath]]];
    }
    else{
        if(imgMsg.sentStatus == ZIMMessageSentStatusSendFailed){
            self.msgStatusImageView.hidden = false;
        }
        NSData *imageData = [NSData dataWithContentsOfFile:imgMsg.fileLocalPath];
        if(imageData == nil){
            imageData = [NSData dataWithContentsOfFile:imgMsg.largeImageLocalPath];
        }
        if(imageData == nil){
            imageData = [NSData dataWithContentsOfFile:imgMsg.thumbnailLocalPath];
        }
        if(imageData == nil){
            self.progressView.progress = 0.0;
            [self.sendImage setImage:[UIImage imageNamed:@"photo"]];
            [[ZGZIMManager shared] downloadMediaFileWithMessage:imgMsg fileType:ZIMMediaFileTypeOriginalFile progress:^(ZIMMessage * _Nonnull message, unsigned long long currentFileSize, unsigned long long totalFileSize) {
                    
            } callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
                if(errorInfo.code == 0){
                    NSData *data = [NSData dataWithContentsOfFile:((ZIMImageMessage *)message).fileLocalPath];
                    if(data != nil){
                        [self.sendImage setImage:[UIImage imageWithData:data]];
                    }
                    callback(Update, message);
                }
            }];
        }
        if(imageData != nil){
            [self.sendImage setImage:[UIImage imageWithData:imageData]];
        }
        

    }
}



@end
