//
//  AddGroupMemberViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/2/20.
//

#import "AddGroupMemberViewController.h"
#import "GroupSetViewController.h"
#import "AddGroupMemberTableViewCell.h"
#import "ZGZIMManager.h"
#import "ZGHUDHelper.h"
@interface AddGroupMemberViewController ()<ZIMEventDelegate>

@property NSMutableArray *addGroupMemberList;

@property (weak, nonatomic) IBOutlet UITextField *userIDTextField;
@property (weak, nonatomic) IBOutlet UITableView *userIDListTableView;

@property (weak, nonatomic) IBOutlet UILabel *unreadMessageCountLabel;
@property (weak, nonatomic) IBOutlet UIButton *addButton;

@property (weak, nonatomic) IBOutlet UIButton *saveButton;

@end

@implementation AddGroupMemberViewController


- (void)viewDidLoad {
    [super viewDidLoad];
    [self.addButton setTitle:NSLocalizedString(@"add", nil) forState:UIControlStateNormal];
    [self.saveButton setTitle:NSLocalizedString(@"OK", nil) forState:UIControlStateNormal];
    self.addGroupMemberList = [[NSMutableArray alloc] init];
    [[ZGZIMManager shared] addZIMEventDelegate:self];
    self.unreadMessageCountLabel.text = [NSString stringWithFormat:@"%@(%u)",NSLocalizedString(@"Unread Message",nil),self.masterVC.unreadMessageCount];
    
}
- (IBAction)backButtonClicked:(UIButton *)sender {
    [self.view.window setRootViewController:self.masterVC];
    
}

- (IBAction)addGroupIDButtonClicked:(UIButton *)sender {
    if(self.userIDTextField.text != nil &&![self.userIDTextField.text isEqual:@""]){
        [self.addGroupMemberList addObject:self.userIDTextField.text];
        [self.userIDListTableView reloadData];
    }
    
}

-(void)removeTheClickedUserID:(NSString *)userID{
    NSString *targetUserID;
    for (NSString *candidateUserID in self.addGroupMemberList) {
        if([candidateUserID isEqual: userID]){
            targetUserID = candidateUserID;
            break;
        }
    }
    [self.addGroupMemberList removeObject:targetUserID];
    [self.userIDListTableView reloadData];
}

- (IBAction)saveUpdateButtonClicked:(UIButton *)sender {
    [[ZGZIMManager shared] inviteUsersIntoGroup:self.addGroupMemberList groupID:self.myGroupID callback:^(NSString * _Nonnull groupID, NSArray<ZIMGroupMemberInfo *> * _Nonnull userList, NSArray<ZIMErrorUserInfo *> * _Nonnull errorUserList, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            [ZGHUDHelper showMessage:@"success"];
            [self.navigationController popViewControllerAnimated:NO];
        }else{
            [ZGHUDHelper showMessage:[NSString stringWithFormat:@"failed！,error code:%d,error message:%@",(int)errorInfo.code,errorInfo.message]];
        }
    }];
}
//MARK: - TableViewDelegate
- (NSInteger)tableView:(nonnull UITableView *)tableView numberOfRowsInSection:(NSInteger)section {

    return self.addGroupMemberList.count;
}

- (nonnull UITableViewCell *)tableView:(nonnull UITableView *)tableView cellForRowAtIndexPath:(nonnull NSIndexPath *)indexPath {
    AddGroupMemberTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"AddGroupMemberTableViewCell"];
    cell.masterVc = self;
    cell.myUserID = self.addGroupMemberList[indexPath.row];
    cell.userIDLabel.text = self.addGroupMemberList[indexPath.row];
    return cell;
}

- (void)conversationTotalUnreadMessageCountUpdated:(unsigned int)totalUnreadMessageCount{
    self.unreadMessageCountLabel.text = [NSString stringWithFormat:@"%@(%u)",NSLocalizedString(@"Unread Message",nil),totalUnreadMessageCount];
}
@end
