//
//  ChangeGroupBoardViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/2/18.
//

#import "ChangeGroupBoardViewController.h"
#import "GroupSetViewController.h"
#import "ZGHUDHelper.h"
#import "ZGZIMManager.h"
@interface ChangeGroupBoardViewController ()<ZIMEventDelegate>
@property (weak, nonatomic) IBOutlet UITextView *groupBoardTextView;
@property (weak, nonatomic) IBOutlet UILabel *unreadMessageCountLabel;
@property (weak, nonatomic) IBOutlet UIButton *saveButton;

@end

@implementation ChangeGroupBoardViewController


- (void)viewDidLoad {
    [super viewDidLoad];
    self.groupBoardTextView.layer.borderWidth = 1;
    [[ZGZIMManager shared] addZIMEventDelegate:self];
    self.unreadMessageCountLabel.text = [NSString stringWithFormat:@"%@(%u)",NSLocalizedString(@"Unread Message",nil),self.masterVC.unreadMessageCount];
    [self.saveButton setTitle:NSLocalizedString(@"OK", nil) forState:UIControlStateNormal];
}

- (IBAction)backButtonClicked:(UIButton *)sender {
    [self.view.window setRootViewController:self.masterVC];
}
- (IBAction)SaveUpdateButtonClicked:(UIButton *)sender {
    [[ZGZIMManager shared] updateGroupNotice:self.groupBoardTextView.text groupID:self.myGroupID callback:^(NSString * _Nonnull groupID, NSString * _Nonnull groupNotice, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            [ZGHUDHelper showMessage:@"success!"];
            sleep(1);
            [self.view.window setRootViewController:self.masterVC];
        }
    }];
}
- (void)conversationTotalUnreadMessageCountUpdated:(unsigned int)totalUnreadMessageCount{
    self.unreadMessageCountLabel.text = [NSString stringWithFormat:@"%@(%u)",NSLocalizedString(@"Unread Message",nil),totalUnreadMessageCount];
}
@end
