//
//  ChangeGroupMarkViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/2/18.
//

#import "ChangeGroupMarkViewController.h"
#import "GroupSetViewController.h"
#import "ZGZIMManager.h"
#import "ZGHUDHelper.h"
@interface ChangeGroupMarkViewController ()<ZIMEventDelegate>
@property (weak, nonatomic) IBOutlet UITextView *groupMarkTextView;

@property (weak, nonatomic) IBOutlet UILabel *unreadMessageCountLabel;
@property (weak, nonatomic) IBOutlet UIButton *saveButton;

@end

@implementation ChangeGroupMarkViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self.saveButton setTitle:NSLocalizedString(@"OK", nil) forState:UIControlStateNormal];
    self.groupMarkTextView.layer.borderWidth = 1;
    [[ZGZIMManager shared] addZIMEventDelegate:self];
    self.unreadMessageCountLabel.text = [NSString stringWithFormat:@"%@(%u)",NSLocalizedString(@"Unread Message",nil),self.masterVC.unreadMessageCount];
    // Do any additional setup after loading the view.
}
- (IBAction)backButtonClicked:(id)sender {
    [self.view.window setRootViewController:self.masterVC];
}
- (IBAction)saveGroupMarkButtonClicked:(UIButton *)sender {
    NSMutableDictionary *markDic = [[NSMutableDictionary alloc] init];
    [markDic setObject:_groupMarkTextView.text forKey:@"GroupMark"];
    [[ZGZIMManager shared] setGroupAttributes:markDic groupID:_myGroupID callback:^(NSString * _Nonnull groupID, NSArray<NSString *> * _Nonnull errorKeys, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            [ZGHUDHelper showMessage:@"success！"];
            [self.view.window setRootViewController:self.masterVC];
        }else{
            [ZGHUDHelper showMessage:@"failed，error code:%d,error message:%@"];
        }
    }];

}
- (void)conversationTotalUnreadMessageCountUpdated:(unsigned int)totalUnreadMessageCount{
    self.unreadMessageCountLabel.text = [NSString stringWithFormat:@"%@(%u)",NSLocalizedString(@"Unread Message",nil),totalUnreadMessageCount];
}
@end
