//
//  changeGroupNameViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/2/18.
//

#import "ChangeGroupNameViewController.h"
#import "GroupSetViewController.h"
#import "ZGZIMManager.h"
#import "ZGHUDHelper.h"
@interface ChangeGroupNameViewController ()<ZIMEventHandler>

@property (weak, nonatomic) IBOutlet UILabel *groupUnreadMessageLabel;

@property (weak, nonatomic) IBOutlet UIButton *saveButton;

@property NSString *groupName;

@end

@implementation ChangeGroupNameViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self.saveButton setTitle:NSLocalizedString(@"OK", nil) forState:UIControlStateNormal];
    self.groupUnreadMessageLabel.text = [NSString stringWithFormat:@"%@(%u)",NSLocalizedString(@"Unread Message",nil),self.masterVC.unreadMessageCount];
    [[ZGZIMManager shared] addZIMEventDelegate:(id)self];
}
- (IBAction)BackButtonClicked:(id)sender {
    [self.view.window setRootViewController:self.masterVC];
}
- (IBAction)groupNameTextFieldDidChanged:(UITextField *)sender {
    self.groupName = sender.text;
}
- (IBAction)saveChangeButtonClicked:(UIButton *)sender {
    [[ZGZIMManager shared] updateGroupName:self.groupName groupID:self.myGroupID callback:^(NSString * _Nonnull groupID, NSString * _Nonnull groupName, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            [ZGHUDHelper showMessage:@"success!"];
            sleep(1);
            [self.view.window setRootViewController:self.masterVC];
        }else{
            [ZGHUDHelper showMessage:[NSString stringWithFormat:@"failed，error code:%lu,error message:%@",errorInfo.code,errorInfo.message]];
        }
    }];
}
- (void)conversationTotalUnreadMessageCountUpdated:(unsigned int)totalUnreadMessageCount{
    self.groupUnreadMessageLabel.text = [NSString stringWithFormat:@"%@(%u)",NSLocalizedString(@"Unread Message",nil),totalUnreadMessageCount];
}

@end
