//
//  RemoveGroupMemberViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/2/20.
//

#import "RemoveGroupMemberViewController.h"
#import "GroupSetViewController.h"
#import "RemoveGroupMemberTableViewCell.h"
#import "ZGZIMManager.h"
#import "ZGHUDHelper.h"
@interface RemoveGroupMemberViewController ()<ZIMEventDelegate>
@property NSArray<ZIMGroupMemberInfo *> *myUserList;
@property NSMutableArray *selectGroupMemberList;


@property (weak, nonatomic) IBOutlet UITableView *userIDListTableView;
@property (weak, nonatomic) IBOutlet UILabel *unreadMessageCountLabel;
@property (weak, nonatomic) IBOutlet UIButton *okButton;

@end

@implementation RemoveGroupMemberViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self.okButton setTitle:NSLocalizedString(@"OK", nil) forState:UIControlStateNormal];
    [[ZGZIMManager shared] addZIMEventDelegate:self];
    self.unreadMessageCountLabel.text = [NSString stringWithFormat:@"%@(%u)",NSLocalizedString(@"Unread Message",nil),self.masterVC.unreadMessageCount];
    self.selectGroupMemberList = [[NSMutableArray alloc] init];
    ZIMGroupMemberQueryConfig *config = [[ZIMGroupMemberQueryConfig alloc] init];
    config.count = 100;
    [[ZGZIMManager shared] queryGroupMemberListByGroupID:self.myGroupID config:config callback:^(NSString * _Nonnull groupID, NSArray<ZIMGroupMemberInfo *> * _Nonnull userList, unsigned int nextFlag, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            self.myUserList = userList;
            [self.userIDListTableView reloadData];
        }
    }];

    // Do any additional setup after loading the view.
}
- (IBAction)backButtonClicked:(UIButton *)sender {
    [self.view.window setRootViewController:self.masterVC];
}

-(void)selectTheUserID:(nonnull NSString *)selectedUserID{
    [self.selectGroupMemberList addObject:selectedUserID];
}

-(void)unSelectTheUserID:(nonnull NSString *)unSelectedUserID{
    [self.selectGroupMemberList removeObject:unSelectedUserID];
}
- (IBAction)verifyUpdateButtonClicked:(UIButton *)sender {
    [[ZGZIMManager shared] kickGroupMembers:(NSArray *)self.selectGroupMemberList groupID:self.myGroupID callback:^(NSString * _Nonnull groupID, NSArray<NSString *> * _Nonnull kickedUserIDList, NSArray<ZIMErrorUserInfo *> * _Nonnull errorUserList, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            [ZGHUDHelper showMessage:@"操作成功！"];
            GroupSetViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"GroupSetViewController"];
            vc.masterVc = self.masterVC.masterVc;
            vc.myGroupID = self.myGroupID;
            [self.view.window setRootViewController:vc];
        }
    }];
}

//MARK: - TableViewDelegate
- (NSInteger)tableView:(nonnull UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return self.myUserList.count;
}

- (nonnull UITableViewCell *)tableView:(nonnull UITableView *)tableView cellForRowAtIndexPath:(nonnull NSIndexPath *)indexPath {
    RemoveGroupMemberTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RemoveGroupMemberTableViewCell"];
    ZIMGroupMemberInfo *memberInfo = self.myUserList[indexPath.row];
    if(![memberInfo.memberNickname isEqual:@""]){
        cell.groupMemberNameLabel.text = memberInfo.memberNickname;
    }else if (![memberInfo.userName isEqual:@""]){
        cell.groupMemberNameLabel.text = memberInfo.userName;
    }else{
        cell.groupMemberNameLabel.text = memberInfo.userID;
    }
    cell.masterVC = self;
    cell.myUserID = memberInfo.userID;
    return cell;
}
- (void)conversationTotalUnreadMessageCountUpdated:(unsigned int)totalUnreadMessageCount{
    self.unreadMessageCountLabel.text = [NSString stringWithFormat:@"%@(%u)",NSLocalizedString(@"Unread Message",nil),totalUnreadMessageCount];
}
@end
