//
//  JoinGroupViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/1/21.
//

#import "JoinGroupViewController.h"
#import "ZGZIMManager.h"
#import "GroupViewController.h"
#import "TabBarViewController.h"
#import "ZGHUDHelper.h"
@interface JoinGroupViewController ()

@property NSString *groupID;
@property (weak, nonatomic) IBOutlet UIButton *joinButton;

@end

@implementation JoinGroupViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    [self.joinButton setTitle:@"join" forState:UIControlStateNormal];
}
- (IBAction)backButtonClicked:(UIButton *)sender {
    UITabBarController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"TabBarViewController"];
    CATransition *animation = [CATransition animation];
    animation.duration = 0.15f;
    animation.type = kCATransitionPush;
    animation.removedOnCompletion = YES;
    animation.subtype = kCATransitionFromLeft;
    [self.view.window.layer addAnimation:animation forKey:nil];
    [self.view.window setRootViewController:vc];
}

- (IBAction)groupIDTextFieldDidChanged:(UITextField *)sender {
    self.groupID = sender.text;
}
- (IBAction)joinGroupButtonClicked:(UIButton *)sender {
    [[ZGZIMManager shared] joinGroup:self.groupID callback:^(ZIMGroupFullInfo * _Nonnull groupInfo, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            GroupViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"GroupViewController"];
            vc.toGroupID = self.groupID;
            [self.navigationController pushViewController:vc animated:YES];
        }else{
            [ZGHUDHelper showMessage:[NSString stringWithFormat:@"failed!error code ：%lu,error message:%@",(unsigned long)errorInfo.code,errorInfo.message]];
        }
    }];

}

@end
