//
//  LoginSettingViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/5/25.
//

#import "LoginSettingViewController.h"
#import "KeyCenter.h"
#import "LoginViewController.h"
#import <ZIM/ZIM.h>
@interface LoginSettingViewController ()
@property (weak, nonatomic) IBOutlet UITextField *appIDTextField;
@property (weak, nonatomic) IBOutlet UITextField *secretTextField;
@property (weak, nonatomic) IBOutlet UITextField *appSignTextField;
@property (weak, nonatomic) IBOutlet UISwitch *isUseTokenSwitch;
@property (weak, nonatomic) IBOutlet UILabel *sdkVerLabel;
@property (weak, nonatomic) IBOutlet UITextField *resourceIDTextField;

@end

@implementation LoginSettingViewController

- (void)viewDidLoad {
    [self.isUseTokenSwitch setOn:KeyCenter.isUseToken];
    //[self.appSignTextField setText:KeyCenter.appSign];
    self.navigationItem.title = @"Settings";
    NSUserDefaults *userDefault = [NSUserDefaults standardUserDefaults];
    NSNumber *appIDNsnumberCach = [userDefault objectForKey:@"appID"];
    NSString *appSignCach = [userDefault objectForKey:@"appSign"];
    [self.appIDTextField setText:[NSString stringWithFormat:@"%u",([appIDNsnumberCach unsignedIntValue]!=0) &&(appIDNsnumberCach != nil)?[appIDNsnumberCach unsignedIntValue]:KeyCenter.appID]];
    [self.appSignTextField setText:(appSignCach != nil && ![appSignCach isEqual:@""])?appSignCach:KeyCenter.appSign];
    if(KeyCenter.resourceID == @""){
        [self.resourceIDTextField setText:@"push_resources_"];
    }else{
        [self.resourceIDTextField setText:KeyCenter.resourceID];
    }
    [self.sdkVerLabel setText:[ZIM getVersion]];
    [super viewDidLoad];
    // Do any additional setup after loading the view.
}

- (IBAction)backButtonClicked:(UIButton *)sender {
    
//    LoginViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"LoginViewController"];
//    [self.view.window setRootViewController:vc];
    [self.navigationController popViewControllerAnimated:YES];
}



- (IBAction)okButtonClicked:(UIButton *)sender {
    
    NSNumberFormatter *f = [[NSNumberFormatter alloc] init];
    f.numberStyle = NSNumberFormatterDecimalStyle;
    NSNumber *appIDNsnumber = [f numberFromString:self.appIDTextField.text];
        
    if(self.appIDTextField.text != nil){
        [KeyCenter setAppID:appIDNsnumber.unsignedIntValue];
    }
    if(self.appSignTextField.text != nil){
        [KeyCenter setAppSign:self.appSignTextField.text];
    }
    [KeyCenter setIsUseToken:self.isUseTokenSwitch.on];
    [KeyCenter setResourceID:self.resourceIDTextField.text];
    NSUserDefaults *userDefault = [NSUserDefaults standardUserDefaults];
    [userDefault setObject:appIDNsnumber forKey:@"appID"];
    [userDefault setObject:self.appSignTextField.text forKey:@"appSign"];
    NSNumber *isUseTokenNsNumber = [NSNumber numberWithBool:self.isUseTokenSwitch.on];
    [userDefault setObject:isUseTokenNsNumber forKey:@"isUseToken"];
    [self.navigationController popViewControllerAnimated:NO];
    
}

-(void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
    [self.appIDTextField resignFirstResponder];
    [self.secretTextField resignFirstResponder];
    [self.resourceIDTextField resignFirstResponder];
}

@end
