//
//  TabBarViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/1/19.
//

#import "TabBarViewController.h"
#import "ZGZIMManager.h"
#import "ZGPopMenuView.h"
#import "CreatePeerViewController.h"
#import "CreateGroupViewController.h"
#import "CreateRoomViewController.h"
#import "JoinGroupViewController.h"
#import "JoinRoomViewController.h"
#import "CreateCallViewController.h"
#import "GlobalSearchViewController.h"

@interface TabBarViewController ()

@end

@implementation TabBarViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self.navigationController setNavigationBarHidden:NO];
    [[ZGZIMManager shared] addZIMEventDelegate:(id)self];
    self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithImage:[UIImage imageNamed:@"plus-3"] style:UIBarButtonItemStyleDone target:self action:@selector(setButtonClicked:event:)];
    self.navigationItem.title = @"ZEGO IM";
    
    // Do any additional setup after loading the view
}

- (CGRect)frameForBarButtonItem:(UIBarButtonItem *)buttonItem
{
    UIView *view = [buttonItem valueForKey:@"view"];
    return  view ? view.frame : CGRectZero;
}

-(void)setButtonClicked:(UIBarButtonItem *)sender
                  event:(UIEvent *) event{
    UIView *view = [sender valueForKey:@"view"];
    [ZGPopMenuView showWithItems:@[
                                   @{@"title":NSLocalizedString(@"Create a 1v1 chat",nil),@"imageName":@"popMenu_scanCard"},
                                   @{@"title":NSLocalizedString(@"Create a group chat",nil),@"imageName":@"popMenu_writeReport"},
                                   @{@"title":NSLocalizedString(@"Join a group",nil),@"imageName":@"popMenu_writeReport"},
                                   @{@"title":NSLocalizedString(@"Create a room",nil),@"imageName":@"popMenu_writeReport"},
                                   @{@"title":NSLocalizedString(@"Join a room",nil),@"imageName":@"popMenu_signIn"},
                                   @{@"title":NSLocalizedString(@"Create call",nil)},
                                     @{@"title":NSLocalizedString(@"Global search",nil)}]
                           width:160
                triangleLocation:CGPointMake([UIScreen mainScreen].bounds.size.width-30, view.frame.size.height+45)
                          action:^(NSInteger index) {
        switch (index) {
            case 0:{
                CreatePeerViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"CreatePeerViewController"];
                [self.navigationController pushViewController:vc animated:YES];
                //[self.view.window setRootViewController:vc];
                break;
            }
            case 1:{
                CreateGroupViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"CreateGroupViewController"];
                [self.navigationController pushViewController:vc animated:YES];
                break;
            }
            case 2:{
                JoinGroupViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"JoinGroupViewController"];
                [self.navigationController pushViewController:vc animated:YES];
                break;
            }
            case 3:{
                CreateRoomViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"CreateRoomViewController"];
                [self.navigationController pushViewController:vc animated:YES];
                break;
            }
            case 4:{
                JoinRoomViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"JoinRoomViewController"];
                [self.navigationController pushViewController:vc animated:YES];
                break;
            }
            case 5:{
                CreateCallViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"CreateCallViewController"];
                vc.viewTitle = @"创建会议";
                [self.navigationController pushViewController:vc animated:YES];
                break;
            }
//            case 6:{
//                GlobalSearchViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"GlobalSearchViewController"];
//                vc.viewTitle = @"消息全局搜索";
//                [self.navigationController pushViewController:vc animated:YES];
//                break;
//            }
            default:
                break;
        }
    }];
}

@end
