//
//  CreatePeerViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/1/20.
//

#import "CreatePeerViewController.h"
#import "PeerViewController.h"
#import "ZGZIMManager.h"
#import "LoginViewController.h"
#import "ConversationListDataSource.h"
#import "ZGHUDHelper.h"
@interface CreatePeerViewController ()

@property NSString *toUserID;

@property (weak, nonatomic) IBOutlet UIButton *createButton;
@property (weak, nonatomic) IBOutlet UIButton *backButton;

@end

@implementation CreatePeerViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.toUserID = @"";
    [self.createButton setTitle:NSLocalizedString(@"create", nil) forState:UIControlStateNormal];
    [self.backButton setTitle:@"" forState:(UIControlState)UIControlStateNormal];
    // Do any additional setup after loading the view.
}
- (IBAction)toUserIDTextFieldDidChanged:(UITextField *)sender {
    self.toUserID = sender.text;
}

- (IBAction)createButtonClicked:(UIButton *)sender {
    NSArray *userlist = @[self.toUserID];
    ZIMUsersInfoQueryConfig *config = [[ZIMUsersInfoQueryConfig alloc] init];
    config.isQueryFromServer = true;
    [[ZGZIMManager shared] queryUsersInfo:userlist config:config callback:^(NSArray<ZIMUserFullInfo *> * _Nonnull userList, NSArray<ZIMErrorUserInfo *> * _Nonnull errorUserList, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0 && userlist.count == 1){
            [self createSuccess];
        }
        else if (errorInfo.code == 6000011){
            [ZGHUDHelper showMessage:[NSString stringWithFormat:@"%@",NSLocalizedString(@"user is not exist!",nil)]];
        }
        else{
            [ZGHUDHelper showMessage:[NSString stringWithFormat:@"%@errorcode:%d,messaage:%@",NSLocalizedString(@"Failed to query user info!",nil),(int)errorInfo.code,errorInfo.message]];
        }
    }];
}
- (IBAction)backButtonClicked:(UIButton *)sender {
    UITabBarController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"TabBarViewController"];
    CATransition *animation = [CATransition animation];
    animation.duration = 0.15f;
    animation.type = kCATransitionPush;
    animation.removedOnCompletion = YES;
    animation.subtype = kCATransitionFromLeft;
    [self.view.window.layer addAnimation:animation forKey:nil];
    [self.view.window setRootViewController:vc];
}


-(void)createSuccess{
    PeerViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"PeerViewController"];
    vc.toUserID = self.toUserID;
    [self.navigationController pushViewController:vc animated:YES];
    NSMutableArray *marr = [[NSMutableArray alloc]initWithArray:self.navigationController.viewControllers];
    for (UIViewController *vc in marr) {
        if (vc == self) {
            [marr removeObject:vc];
            break;          //break一定要加，不加有时候有bug
        }
    }
    self.navigationController.viewControllers = marr;


}
@end
