//
//  PeerSendMsgTableViewCell.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/1/20.
//

#import "PeerSendMsgTableViewCell.h"
#import "ZGZIMManager.h"
#import "MBProgressHUD.h"
@interface PeerSendMsgTableViewCell()

@property (weak, nonatomic) IBOutlet UIImageView *msgStatusImageView;


@end


@implementation PeerSendMsgTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];
    
    // Configure the view for the selected state
}


-(void)readyToshow:(ZIMMessage *)message
      userFullInfo:(ZIMUserFullInfo *)userFullInfo
          callback:(void(^)(MessageCellEvent event,ZIMMessage * msg))callback{
    switch (message.sentStatus) {
        case ZIMMessageSentStatusSendFailed:
            [self.msgStatusImageView setImage:[UIImage imageNamed:@"gantanhao-2"]];
            self.msgStatusImageView.hidden = false;
            break;
        case ZIMMessageSentStatusSending:{
            [self.msgStatusImageView setImage:[UIImage imageNamed:@"loading"]];
            self.msgStatusImageView.hidden = false;
            break;
        }
        case ZIMMessageSentStatusSendSuccess:{
            if(message.receiptStatus == ZIMMessageReceiptStatusProcessing){
                [self.msgStatusImageView setImage:[UIImage imageNamed:@"duigou"]];
                self.msgStatusImageView.hidden = false;
            }else if(message.receiptStatus == ZIMMessageReceiptStatusDone){
                [self.msgStatusImageView setImage:[UIImage imageNamed:@"duigou-xuanzhong"]];
                self.msgStatusImageView.hidden = false;
            }
            else{
                self.msgStatusImageView.hidden = true;
            }
            break;
        }
        default:
            break;
    }
    self.readayToShowCallback = callback;
    self.message = message;
    [self.msgContentLabel setText:((ZIMTextMessage *)message).message];
    if(userFullInfo.extendedData != nil && ![userFullInfo.extendedData  isEqual:@""]){
        NSData *extendedData = [userFullInfo.extendedData dataUsingEncoding:NSUTF8StringEncoding];
        NSDictionary *dict = [NSJSONSerialization JSONObjectWithData:extendedData options:kNilOptions error:nil];
        NSString *avatarURL = [dict objectForKey:@"avatar"];
        self.avatar.image = [UIImage imageWithData:[NSData dataWithContentsOfURL:[NSURL URLWithString:avatarURL]]];
    }
    
}

@end
