//
//  PeerViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/1/20.
//

#import "PeerViewController.h"
#import "PeerReceiveMsgTableViewCell.h"
#import "PeerSendMsgTableViewCell.h"
#import "KeyboardToolBar.h"
#import "ZGZIMManager.h"
#import "ConversationListDataSource.h"
#import "MJRefresh.h"
#import "ZGHUDHelper.h"
#import <AVFoundation/AVFoundation.h>
#import <AVKit/AVKit.h>
#import "PeerSendMsgTableViewCell.h"
#import "PeerReceiveMsgTableViewCell.h"
#import "KeyCenter.h"
#import "PeersendImageMessageTableViewCell.h"
#import "PeerReceiveImageMessageTableViewCell.h"
#import "PeerSendVideoMessageTableViewCell.h"
#import "PeerReceiveVideoMessageTableViewCell.h"
#import "PeerSendFileMessageTableViewCell.h"
#import "PeerReceiveFileMessageTableViewCell.h"
#import "CallInviteView.h"
#import "RevokeMsgTableViewCell.h"
#import "CallKitManager.h"
#import "ZIMPluginConverter.h"

@interface PeerViewController ()<UITableViewDelegate,UITableViewDataSource,UITextViewDelegate,ZIMEventDelegate>
@property (weak, nonatomic) IBOutlet UIButton *backButton;
@property (weak, nonatomic) IBOutlet UIButton *chatSetButton;

@property (weak, nonatomic) IBOutlet UIButton *sendButton;

@property (weak, nonatomic) IBOutlet UIView *nowChatView;

@property UIView *chatSetView;

@property UIView *chatMainView;

@property NSMutableArray<ZIMMessage *> * _Nonnull historyMessageList;

@property (weak, nonatomic) IBOutlet UITableView *peerTableView;

@property (weak, nonatomic) IBOutlet UITextView *chatTextView;

@property NSString *sendMessageStr;

@property NSString *filePath;

@property NSString *imagePath;

@property  UIImagePickerController *imagePickerCtrl;

@property (weak, nonatomic) IBOutlet UIImageView *receiptImageView;

@end

@implementation PeerViewController

//-(void)setShadow:(UIView *)targetView{
//    targetView.layer.shadowColor = [UIColor grayColor].CGColor;
//    targetView.layer.shadowOffset = CGSizeMake(0,0);
//    targetView.layer.shadowOpacity = 0.5;
//    targetView.layer.shadowRadius = 1;
//    float shaowPathWidth = targetView.layer.shadowRadius;
//    CGRect shadowRect = CGRectMake(-[UIScreen mainScreen].bounds.size.width/ 2.0, 0-[UIScreen mainScreen].bounds.size.width, targetView.bounds.size.width+shaowPathWidth, [UIScreen mainScreen].bounds.size.width);
//    UIBezierPath *path = [UIBezierPath bezierPathWithRect: shadowRect];
//    targetView.layer.shadowPath = path.CGPath;
//}
- (void)willMoveToParentViewController:(UIViewController*)parent{
    [super willMoveToParentViewController:parent];
    if(parent == nil){
        [[ZGZIMManager shared] removeZIMEventDelegate:self];
    }else{
        [[ZGZIMManager shared] addZIMEventDelegate:self];
    }

}


- (void)viewDidLoad {
    [super viewDidLoad];
   // [self setShadow:self.nowChatView];
    [self.backButton setTitle:@"" forState:UIControlStateNormal];
    [self.chatSetButton setTitle:@"" forState:UIControlStateNormal];
    [self.sendButton setTitle:NSLocalizedString(@"send",nil) forState:UIControlStateNormal];
    self.historyMessageList = [[NSMutableArray alloc] init];
    [KeyboardToolBar registerKeyboardToolBarWithTextView:_chatTextView];
    self.chatTextView.layer.borderWidth = 2;
    self.navigationItem.title = self.toUserID;
//    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        // 耗时的操作
//        dispatch_async(dispatch_get_main_queue(), ^{
//            // 更新界面
//        });
//    });

//    ZIMUserInfoQueryConfig *config = [[ZIMUserInfoQueryConfig alloc] init];
//    config.isQueryFromServer = true;
//    [[ZIM getInstance] queryUsersInfo:@[self.toUserID,[ZGZIMManager shared].myUserID] config:config callback:^(NSArray<ZIMUserFullInfo *> * _Nonnull userList, NSArray<ZIMErrorUserInfo *> * _Nonnull errorUserList, ZIMError * _Nonnull errorInfo) {
//        if(errorInfo.code == 0){
//            for (ZIMUserFullInfo *userFullInfo in userList) {
//                if([userFullInfo.baseInfo.userID isEqual:[ZGZIMManager shared].myUserID]){
//                    self.myUserFullInfo = userFullInfo;
//                }else{
//                    self.toUserFullInfo = userFullInfo;
//                    [self.userNameLabel setText:self.toUserFullInfo.baseInfo.userName];
//                }
//            }
//        }
//        [self renewTableView:false];
//    }];
//    [[ZGZIMManager shared] queryUsersInfo:@[self.toUserID,[ZGZIMManager shared].myUserID] callback:^(NSArray<ZIMUserFullInfo *> * _Nonnull userList, NSArray<ZIMErrorUserInfo *> * _Nonnull errorUserList, ZIMError * _Nonnull errorInfo) {
//
//    }];
    
    [[ZGZIMManager shared] addZIMEventDelegate:self];
    [self clearConversationUnreadMessageCount];
    [self queryHistoryMessage];
    [self sendConversationMessageReceiptRead];
    self.peerTableView.mj_header = [MJRefreshNormalHeader headerWithRefreshingBlock:^{
        [self queryHistoryMessage];
        [self.peerTableView.mj_header endRefreshing];
    }];
    UILongPressGestureRecognizer *gesture = [[UILongPressGestureRecognizer alloc]  initWithTarget:self action:@selector(didLongPressTableViewCell:)];
    gesture.minimumPressDuration = 1.0;
    [self.peerTableView addGestureRecognizer:gesture];
}
-(void)clearConversationUnreadMessageCount{
    NSLog(@"[510]clear touserid:%@",_toUserID);
    [[ZGZIMManager shared] clearConversationUnreadMessageCount:self.toUserID type:0 callback:^(NSString * _Nonnull conversationID, ZIMConversationType conversationType, ZIMError * _Nonnull errorInfo) {
        NSLog(@"[510]cleared errorcode:%lu,message:%@",(unsigned long)errorInfo.code,errorInfo.message);
    }];
}
-(void)queryHistoryMessage{
    ZIMMessageQueryConfig *config = [[ZIMMessageQueryConfig alloc] init];
    config.count = 20;
    config.reverse = true;
    bool firstQuery = true;
    if(self.historyMessageList.count>0){
        config.nextMessage = self.historyMessageList[0];
        firstQuery = false;
    }
    [[ZGZIMManager shared] queryHistoryMessage:self.toUserID conversationType:0 config:config callback:^(NSString * _Nonnull conversationID, ZIMConversationType conversationType, NSArray<ZIMMessage *> * _Nonnull messageList, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            if(self.historyMessageList == nil){
                self.historyMessageList = (NSMutableArray *)messageList;
            }else{
                NSMutableArray *newHistoryMessageList = (NSMutableArray *)messageList;
                for (ZIMMessage *message in self.historyMessageList) {
                    [newHistoryMessageList addObject:message];
                }
                self.historyMessageList = newHistoryMessageList;
            }
            [self renewTableView:firstQuery==true?false:true];
        }
    }];
}

-(void)sendConversationMessageReceiptRead{
    [[ZGZIMManager shared] sendConversationMessageReceiptRead:self.toUserID conversationType:ZIMConversationTypePeer callback:^(NSString * _Nonnull conversationID, ZIMConversationType conversationType, ZIMError * _Nonnull errorInfo) {}];
}

- (IBAction)backButtonClicked:(UIButton *)sender {
    UITabBarController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"TabBarViewController"];
    CATransition *animation = [CATransition animation];
    animation.duration = 0.35f;
    animation.type = kCATransitionPush;
    animation.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut];
    animation.removedOnCompletion = YES;
    animation.subtype = kCATransitionFromLeft;
    [self.view.window.layer addAnimation:animation forKey:nil];
    [self.view.window setRootViewController:vc];
    [[ZGZIMManager shared] removeZIMEventDelegate:self];
}

- (IBAction)sendMessageButtonClicked:(UIButton *)sender {
    if(self.chatTextView.text.length > 10){
        self.chatTextView.text= [self.chatTextView.text substringToIndex:9];
    }
    self.sendMessageStr = self.chatTextView.text;
    
    if(self.sendMessageStr != nil &&![self.sendMessageStr isEqual:@""]){
        ZIMTextMessage *txtMsg = [[ZIMTextMessage alloc] init];
        txtMsg.message = _sendMessageStr;
        ZIMMessageSendConfig *sentConfig = [[ZIMMessageSendConfig alloc] init];
        ZIMPushConfig *pushConfig = [[ZIMPushConfig alloc] init];
        pushConfig.title = [ZGZIMManager shared].myUserID;
        pushConfig.content = _sendMessageStr;
        pushConfig.resourcesID = KeyCenter.resourceID;
//        pushConfig.voIPConfig = [[ZIMVoIPConfig alloc] init];
//        pushConfig.voIPConfig.iOSVoIPHandleType = ZIMCXHandleTypeGeneric;
//        pushConfig.voIPConfig.iOSVoIPHandleValue = @"510";
//        pushConfig.voIPConfig.iOSVoIPHasVideo = YES;
        NSString *payload_json = [NSString stringWithFormat:@"{\"avatar_url\":\"https://storage.zego.im/zim/example/web/assets/1.jpeg\",\"image_attachment\":\"https://storage.zego.im/zim/example/web/assets/2.jpeg\"}"];
        pushConfig.payload = payload_json;
        sentConfig.priority = 1;
        sentConfig.pushConfig = pushConfig;
        sentConfig.hasReceipt = !self.receiptImageView.hidden;
        [[ZGZIMManager shared] sendMessage:txtMsg toConversationID:self.toUserID conversationType:ZIMConversationTypePeer config:sentConfig notification:nil callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
            [self renewTableView:false];
        }];
        [self.historyMessageList addObject:txtMsg];
        [self renewTableView:false];
        [self.chatTextView setText:@""];
    }
}

- (IBAction)chatSetButtonClicked:(UIButton *)sender {
    _chatSetView = [[[UINib nibWithNibName:@"GroupChatSetView" bundle:[NSBundle mainBundle]]
                     instantiateWithOwner:self options:nil] lastObject];
    CGRect rect = _chatSetView.frame;
    rect.size.width = [UIScreen mainScreen].bounds.size.width;
    [_chatSetView setFrame:rect];
    
    [_chatSetView setTag:1000];
    _chatMainView = [self.nowChatView.subviews firstObject];
    [self.nowChatView addSubview:_chatSetView];
    
}


- (IBAction)photoButtonClicked:(UIButton *)sender {
    if([UIImagePickerController 

    isSourceTypeAvailable:UIImagePickerControllerSourceTypeSavedPhotosAlbum]){

        UIImagePickerController *imagePickerCtrl = [[UIImagePickerController alloc] init];
        imagePickerCtrl.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
        imagePickerCtrl.delegate = (id)self;
        
        //指定媒体类型,图片(@"public.image"),视频(@"public.movie")
        imagePickerCtrl.mediaTypes = @[@"public.image",@"public.movie"];
        [self presentViewController:imagePickerCtrl animated:YES completion:NULL];
    }
}
- (IBAction)folderButtonClicked:(UIButton *)sender {
    NSArray *types = @[@"public.content",@"public.text"];
    UIDocumentPickerViewController *picker = [[UIDocumentPickerViewController alloc] initWithDocumentTypes:types inMode:UIDocumentPickerModeOpen];
    picker.delegate = (id)self;
    [self presentViewController:picker animated:YES completion:nil];
}

- (IBAction)callInviteButtonClicked:(UIButton *)sender {
    ZIMCallInviteConfig *inviteConfig = [[ZIMCallInviteConfig alloc] init];
    inviteConfig.timeout = 90;
    inviteConfig.mode = ZIMCallInvitationModeGeneral;
    ZIMPushConfig *pushConfig = [[ZIMPushConfig alloc] init];
    pushConfig.resourcesID = KeyCenter.resourceID;
    pushConfig.title = [ZGZIMManager shared].myUserID;
    pushConfig.content = @"邀请你语音通话";
    inviteConfig.pushConfig = pushConfig;
    [[ZGZIMManager shared] callInviteWithInvitees:@[self.toUserID] config:inviteConfig callback:^(NSString * _Nonnull callID, ZIMCallInvitationSentInfo * _Nonnull info, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            [CallInviteView show:Caller userID:self.toUserID callID:callID mode:ZIMCallInvitationModeGeneral];
        }
    }];
}

- (IBAction)receiptButtonClicked:(UIButton *)sender {
    self.receiptImageView.hidden = !self.receiptImageView.hidden;
    [_chatSetView removeFromSuperview];
}

- (IBAction)callTestButtonClicked:(UIButton *)sender {
    ZIMCallInviteConfig *inviteConfig = [[ZIMCallInviteConfig alloc] init];
    inviteConfig.timeout = 60;
    inviteConfig.mode = ZIMCallInvitationModeGeneral;
    ZIMPushConfig *pushConfig = [[ZIMPushConfig alloc] init];
    pushConfig.resourcesID = KeyCenter.resourceID;
    pushConfig.title = [ZGZIMManager shared].myUserID;
    pushConfig.content = @"邀请你语音通话";
    inviteConfig.pushConfig = pushConfig;
    [[ZGZIMManager shared] callInviteWithInvitees:@[self.toUserID] config:inviteConfig callback:^(NSString * _Nonnull callID, ZIMCallInvitationSentInfo * _Nonnull info, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            [ZGZIMManager shared].targetCallID = callID;
            [CallInviteView show:Caller userID:self.toUserID callID:callID mode:ZIMCallInvitationModeGeneral];
        }
    }];
}

- (IBAction)callingTestButtonClicked:(UIButton *)sender {
    ZIMCallingInviteConfig *inviteConfig = [[ZIMCallingInviteConfig alloc] init];
    ZIMPushConfig *pushConfig = [[ZIMPushConfig alloc] init];
    pushConfig.resourcesID = KeyCenter.resourceID;
    pushConfig.title = [ZGZIMManager shared].myUserID;
    pushConfig.content = @"邀请你语音通话";
    inviteConfig.pushConfig = pushConfig;
    [[ZGZIMManager shared] callingInviteWithInvitees:@[self.toUserID] callID:[ZGZIMManager shared].targetCallID config:inviteConfig callback:^(NSString * _Nonnull callID, ZIMCallingInvitationSentInfo * _Nonnull info, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            [ZGZIMManager shared].targetCallID = callID;
            [CallInviteView show:Caller userID:self.toUserID callID:callID mode:ZIMCallInvitationModeGeneral];
        }
    }];
}

- (IBAction)searchButtonClicked:(UIButton *)sender {
    ZIMCallInvitationQueryConfig *callListConfig = [[ZIMCallInvitationQueryConfig alloc] init];
    callListConfig.count = 10;
}

- (IBAction)quitButtonClicked:(UIButton *)sender {
    ZIMCallQuitConfig *quitConfig = [[ZIMCallQuitConfig alloc] init];
    [[ZGZIMManager shared] callQuit:[ZGZIMManager shared].targetCallID config:quitConfig callback:^(NSString * _Nonnull callID, ZIMCallQuitSentInfo * _Nonnull info, ZIMError * _Nonnull errorInfo) {
        
    }];
}

- (IBAction)endButtonClicked:(UIButton *)sender {
    ZIMCallEndConfig *endConfig = [[ZIMCallEndConfig alloc] init];
    [[ZGZIMManager shared] callEnd:[ZGZIMManager shared].targetCallID config:endConfig callback:^(NSString * _Nonnull callID, ZIMCallEndedSentInfo *info, ZIMError * _Nonnull errorInfo) {
        
    }];
}

-(void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
    if([touches anyObject].view.tag != 1000){
        NSLog(@"点击到外部");
        [_chatSetView removeFromSuperview];
        [self.nowChatView addSubview:_chatMainView];
    }else{
        NSLog(@"点击到内部");
    }
    
}

-(void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary<NSString *,id> *)info
{
    
    //拿到图片会就销毁之前的控制器
    [picker dismissViewControllerAnimated:YES completion:nil];
    
    if([[info objectForKey:UIImagePickerControllerMediaType] isEqual:@"public.movie"]){
        NSURL *sourceURL = [info objectForKey:UIImagePickerControllerMediaURL];
//        if(sourceURL == nil){
//            [ZGHUDHelper showMessage:[NSString stringWithFormat:@"Video path is illegal"]];
//            return;
//        }
        [[NSFileManager defaultManager] removeItemAtPath:_filePath error:nil];
        [[NSFileManager defaultManager] removeItemAtPath:_imagePath error:nil];
        NSDateFormatter *formater = [[NSDateFormatter alloc] init];
        [formater setDateFormat:@"yy-MM-dd-HH:mm:ss"];
        
        _filePath = [NSHomeDirectory() stringByAppendingFormat:@"/Documents/%@", [[formater stringFromDate:[NSDate date]] stringByAppendingString:@".mp4"]];

        
        NSString  *videoPath =  info[UIImagePickerControllerMediaURL];
        if(videoPath == nil){
            videoPath = info[UIImagePickerControllerReferenceURL];
        }
        
        NSLog(@"filePath:%@",_filePath);
        NSLog(@"videoPath:%@",videoPath);
        NSFileManager *fileManager = [NSFileManager defaultManager];

        NSError *error;
        [fileManager copyItemAtPath:videoPath toPath:_filePath error:&error];
        if (error)
        {

            NSLog(@"文件保存到缓存失败");
        }

        
        [sourceURL startAccessingSecurityScopedResource];
        
        ZIMVideoMessage *videoMsg = [[ZIMVideoMessage alloc] initWithFileLocalPath:_filePath videoDuration:10];
        [videoMsg setValue:[NSNumber numberWithInt:3] forKey:@"sentStatus"];
        [self.historyMessageList addObject:videoMsg];
        [self renewTableView:false];

    }else if ([[info objectForKey:UIImagePickerControllerMediaType] isEqual:@"public.image"]){
//        info中就是包含你在相册里面选择的图片(info字典里面还有图片的url-有需要的可以将info打印出来取自己要的数据)
        NSURL *url = [info objectForKey:@"UIImagePickerControllerImageURL"];
        
        NSString *urlStr = url.path;
        ZIMImageMessage *message = [[ZIMImageMessage alloc] initWithFileLocalPath:urlStr];
        [message setValue:[NSNumber numberWithInt:3] forKey:@"sentStatus"];
        [self.historyMessageList addObject:message];
        [self renewTableView:false];
    }
}

- (void)documentPicker:(UIDocumentPickerViewController *)controller didPickDocumentsAtURLs:(NSArray<NSURL *> *)urls {
    // 获取授权
    [urls.firstObject startAccessingSecurityScopedResource];
    
    ZIMFileMessage *fileMsg = [[ZIMFileMessage alloc] initWithFileLocalPath:[urls firstObject].path];
    ZIMMessageSendConfig *sendConfig = [[ZIMMessageSendConfig alloc] init];
    sendConfig.priority = 1;
    [fileMsg setValue:[NSNumber numberWithInt:3] forKey:@"sentStatus"];
    [self.historyMessageList addObject:fileMsg];
    [self renewTableView:false];
}


-(void)playSelectVideo:(NSURL *)url{
    AVPlayerViewController *playerVc = [[AVPlayerViewController alloc] init];
    AVPlayer *avPlayer= [AVPlayer playerWithURL:url];
    playerVc.player = avPlayer;
    [self presentViewController:playerVc animated:YES completion:nil];
    [playerVc.player play];
}


//MARK: - TableViewDelegate
- (NSInteger)tableView:(nonnull UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return _historyMessageList.count;
}

- (void)didLongPressTableViewCell:(UILongPressGestureRecognizer *)gesture
{
    if (gesture.state == UIGestureRecognizerStateBegan) {
        //获取到点击的位置
        CGPoint point = [gesture locationInView:self.peerTableView];
        
        NSIndexPath *indexPath = [self.peerTableView indexPathForRowAtPoint:point];
        UITableViewCell *cell = [self.peerTableView cellForRowAtIndexPath:indexPath];
        [cell becomeFirstResponder];
        NSValue *pointValue =  [NSValue valueWithCGPoint:point];
        [cell performSelector:@selector(showMessageMenu:) withObject:pointValue];
        if(indexPath == nil) return;
        
        //do something...
    }
}

- (nonnull UITableViewCell *)tableView:(nonnull UITableView *)tableView cellForRowAtIndexPath:(nonnull NSIndexPath *)indexPath {
    
    ZIMMessage *msg = _historyMessageList[indexPath.row];
    MessageTableViewCell *cell;
    void(^readayToShowCallback)(MessageCellEvent event,ZIMMessage * msg);
    ZIMMessageSendConfig *sendConfig = [[ZIMMessageSendConfig alloc] init];
    sendConfig.hasReceipt = !self.receiptImageView.hidden;
    readayToShowCallback = ^(MessageCellEvent event,ZIMMessage * msg){
        switch (event) {
            case Revoke:{
                [self.historyMessageList replaceObjectAtIndex:indexPath.row withObject:msg];
                break;
            }
            case Delete:{
                [self.historyMessageList removeObject:msg];
                break;
            }
            case Update:{
                //TODO: 这里最好可以回传 cell 对象，然后取一下 cell 在 table view 中的位置，而不是通过闭包捕获
                [self.historyMessageList replaceObjectAtIndex:indexPath.row withObject:msg];
            }
            default:
                break;
        }
        [tableView reloadData];
    };
    if(msg.direction == ZIMMessageDirectionSend){
        if(msg.type == ZIMMessageTypeText){
            ZIMTextMessage *txtMsg = (ZIMTextMessage *)msg;
            cell =[tableView dequeueReusableCellWithIdentifier:@"PeerSendMsgTableViewCell"];
            
            [((PeerSendMsgTableViewCell *)cell) readyToshow:txtMsg userFullInfo:self.myUserFullInfo callback:readayToShowCallback];
            return cell;
            
        }
        else if (msg.type == ZIMMessageTypeImage){
            ZIMImageMessage *imageMsg = (ZIMImageMessage *)msg;
            PeerSendImageMessageTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"PeerSendImageMessageTableViewCell"];
            cell.masterVC = (id)self;
            cell.sendConfig = sendConfig;
            [cell readyToShow:imageMsg callback:readayToShowCallback];
            return cell;
        }
        else if (msg.type == ZIMMessageTypeVideo){
            ZIMVideoMessage *videoMsg = (ZIMVideoMessage *)msg;
            PeerSendVideoMessageTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"PeerSendVideoMessageTableViewCell"];
            cell.masterVC = (id)self;
            cell.sendConfig = sendConfig;
            [cell readyToShow:videoMsg callback:readayToShowCallback];
            return cell;
        }
        else if (msg.type == ZIMMessageTypeFile){
            ZIMFileMessage *filemsg = (ZIMFileMessage *)msg;
            PeerSendFileMessageTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"PeerSendFileMessageTableViewCell"];
            cell.masterVC = (id)self;
            cell.sendConfig = sendConfig;
            [cell readyToShow:filemsg callback:readayToShowCallback];
            return cell;
        }
        else if(msg.type == ZIMMessageTypeRevoke){
            RevokeMsgTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RevokeMsgTableCell"];
            [cell readyToshow:msg callback:readayToShowCallback];
            return cell;
        }
        else{
            ZIMTextMessage *txtMsg = [[ZIMTextMessage alloc] initWithMessage:@"[未知消息类型]"];
            [txtMsg safeSetValue:[NSNumber numberWithInteger:msg.sentStatus] forKey:@"sentStatus"];
            [txtMsg safeSetValue:[NSNumber numberWithInteger:msg.receiptStatus] forKey:@"receiptStatus"];
            cell =[tableView dequeueReusableCellWithIdentifier:@"PeerSendMsgTableViewCell"];
            
            [((PeerSendMsgTableViewCell *)cell) readyToshow:txtMsg userFullInfo:self.myUserFullInfo callback:readayToShowCallback];
            return cell;
        }
    }
    else if(msg.direction == ZIMMessageDirectionReceive){
        if(msg.type == ZIMMessageTypeText){
            ZIMTextMessage *txtMsg = (ZIMTextMessage *)msg;
            PeerReceiveMsgTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"PeerReceiveMsgTableViewCell"];
            [cell readyToshow:txtMsg userFullInfo:self.toUserFullInfo callback:readayToShowCallback];
           
           return cell;
        }
        else if (msg.type == ZIMMessageTypeImage){
            ZIMImageMessage *imageMsg = (ZIMImageMessage *)msg;
            PeerReceiveImageMessageTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"PeerReceiveImageMessageTableViewCell"];
            cell.masterVC = (id)self;
            [cell readyToShow:imageMsg callback:readayToShowCallback];
            return cell;
        }
        else if (msg.type == ZIMMessageTypeVideo){
            ZIMVideoMessage *videoMsg = (ZIMVideoMessage *)msg;
            PeerReceiveVideoMessageTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"PeerReceiveVideoMessageTableViewCell"];
            cell.masterVC = (id)self;
            [cell readyToShow:videoMsg callback:readayToShowCallback];
            return cell;
        }
        else if (msg.type == ZIMMessageTypeAudio){
            ZIMFileMessage *fileMsg = (ZIMFileMessage *)msg;
            PeerReceiveFileMessageTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"PeerReceiveFileMessageTableViewCell"];
            cell.masterVC = (id)self;
            [cell readyToShow:fileMsg callback:readayToShowCallback];
            return cell;
        }
        else if (msg.type == ZIMMessageTypeFile){
            ZIMFileMessage *fileMsg = (ZIMFileMessage *)msg;
            PeerReceiveFileMessageTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"PeerReceiveFileMessageTableViewCell"];
            cell.masterVC = (id)self;
            [cell readyToShow:fileMsg callback:readayToShowCallback];
            return cell;
        }
        else if (msg.type == ZIMMessageTypeCommand){
            //ZIMCommandMessage *cmdMsg = (ZIMCommandMessage *)msg;
            PeerReceiveMsgTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"PeerReceiveMsgTableViewCell"];
           [cell.contentMessageLabel setText:@"[receive a cmd message]"];
           return cell;
        }
        else if(msg.type == ZIMMessageTypeRevoke){
            RevokeMsgTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RevokeMsgTableCell"];
            [cell readyToshow:msg callback:readayToShowCallback];
            return cell;
        }
        else{
            ZIMTextMessage *txtMsg = [[ZIMTextMessage alloc] initWithMessage:@"[未知消息类型]"];
            [txtMsg safeSetValue:[NSNumber numberWithInteger:msg.sentStatus] forKey:@"sentStatus"];
            [txtMsg safeSetValue:[NSNumber numberWithInteger:msg.receiptStatus] forKey:@"receiptStatus"];
            cell =[tableView dequeueReusableCellWithIdentifier:@"PeerSendMsgTableViewCell"];
            
            [((PeerSendMsgTableViewCell *)cell) readyToshow:txtMsg userFullInfo:self.myUserFullInfo callback:readayToShowCallback];
            return cell;
        }
    }
    else{
        
        return 0;
        
    }
    
    return 0;
}


- (void)receivePeerMessage:(NSArray<ZIMMessage *> *)messageList
                fromUserID:(NSString *)fromUserID{
    if(![fromUserID isEqual:self.toUserID]) return;
    NSArray *reverseMsgList = [[messageList reverseObjectEnumerator] allObjects];
    for (ZIMMessage *msg in reverseMsgList) {
        if(msg.type == ZIMMessageTypeCommand) continue;
        [self.historyMessageList addObject:msg];
        if(msg.receiptStatus == ZIMMessageReceiptStatusProcessing){
            [[ZGZIMManager shared] sendMessageReceiptsRead:@[msg] conversationID:self.toUserID conversationType:ZIMConversationTypePeer callback:^(NSString * _Nonnull conversationID, ZIMConversationType conversationType, NSArray<NSNumber *> * _Nonnull errorMessageIDs, ZIMError * _Nonnull errorInfo) {
                if(errorInfo.code == 0){
                    for (ZIMMessage *message in self.historyMessageList) {
                        if(message.messageID == msg.messageID){
                            [message setValue:[NSNumber numberWithUnsignedInteger:ZIMMessageReceiptStatusDone] forKey:@"receiptStatus"];
                        }
                    }
                    
                    [self.peerTableView reloadData];
                }
                
            }];
        }
        
    }
    [self renewTableView:false];
    [self.peerTableView scrollToRowAtIndexPath:[NSIndexPath indexPathForRow:self.historyMessageList.count -1 inSection:0]  atScrollPosition:UITableViewScrollPositionBottom animated:NO];
    [[ZGZIMManager shared] clearConversationUnreadMessageCount:self.toUserID type:0 callback:^(NSString * _Nonnull conversationID, ZIMConversationType conversationType, ZIMError * _Nonnull errorInfo) {}];
}
-(void)renewTableView:(BOOL)isTop{
    [self.peerTableView reloadData];
    dispatch_async(dispatch_get_main_queue(), ^{
        if(isTop == false){
            if(self.historyMessageList.count>0){
                [self.peerTableView scrollToRowAtIndexPath:[NSIndexPath indexPathForRow:self.historyMessageList.count -1 inSection:0]  atScrollPosition:UITableViewScrollPositionBottom animated:YES];
            }
        }else{
            
        }
    });
}

- (void)messageRevokeReceived:(NSArray<ZIMRevokeMessage *> *)messageList{
    for (ZIMRevokeMessage *revokeMessage in messageList) {
        if(![revokeMessage.senderUserID isEqual: self.toUserID]){
            continue;
        }
        if(revokeMessage.conversationType != ZIMConversationTypePeer){
            continue;
        }
        for (ZIMMessage *message in self.historyMessageList) {
            if(message.messageID == revokeMessage.messageID){
                [self.historyMessageList replaceObjectAtIndex:[self.historyMessageList indexOfObject:message] withObject:revokeMessage];
                break;
            }
        }
    }
    [self.peerTableView reloadData];
}

- (void)zim:(ZIM *)zim conversationMessageReceiptChanged:(NSArray<ZIMMessageReceiptInfo *> *)infos{
    for (ZIMMessageReceiptInfo *receiptInfo in infos) {
        if(![receiptInfo.conversationID isEqual: self.toUserID]){
            return;
        }
        for (int index = 0; index< self.historyMessageList.count; index ++) {
            if(self.historyMessageList[index].messageID == receiptInfo.messageID){
                [self.historyMessageList[index] setValue:[NSNumber numberWithUnsignedInteger:receiptInfo.status] forKey:@"receiptStatus"];
                break;
            }
        }
        [self renewTableView:false];
    }
}

- (void)zim:(ZIM *)zim messageReceiptChanged:(NSArray<ZIMMessageReceiptInfo *> *)infos{
    for (ZIMMessageReceiptInfo *receiptInfo in infos) {
        if(![receiptInfo.conversationID isEqual: self.toUserID]){
            return;
        }
        for (int index = 0; index< self.historyMessageList.count; index ++) {
            if(self.historyMessageList[index].messageID == receiptInfo.messageID){
                
                [self.historyMessageList[index] setValue:[NSNumber numberWithUnsignedInteger:receiptInfo.status] forKey:@"receiptStatus"];
                break;
            }
        }
        [self renewTableView:false];
    }
}
@end
