//
//  PeerReceiveFileMessageTableViewCell.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/4/29.
//

#import "PeerReceiveFileMessageTableViewCell.h"
#import "ZGZIMManager.h"
@interface PeerReceiveFileMessageTableViewCell()

@property ZIMFileMessage *fileMsg;

@end

@implementation PeerReceiveFileMessageTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

- (IBAction)downLoadButtonClicked:(UIButton *)sender {
    self.progressView.progress = 0.0;
    self.progressView.hidden = false;
    self.downLoadButton.hidden = true;
    
    [[ZGZIMManager shared] downloadMediaFileWithMessage:self.fileMsg fileType:ZIMMediaFileTypeOriginalFile progress:^(ZIMMessage * _Nonnull message, unsigned long long currentFileSize, unsigned long long totalFileSize) {
        float progress = [NSString stringWithFormat:@"%.2f",(float)currentFileSize/(float)totalFileSize].floatValue;
        [self.progressView setProgress:progress animated:YES];
        
    } callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
        self.progressView.hidden = true;
        if(errorInfo.code == 0){
            self.readayToShowCallback(Update,message);
        }
    }];
    
}

-(void)readyToShow:(ZIMMessage *)message
          callback:(void(^)(MessageCellEvent event,ZIMMessage * msg))callback{
    self.message = message;
    self.readayToShowCallback = callback;
    ZIMFileMessage *fileMsg = (ZIMFileMessage *)message;
    self.fileMsg = fileMsg;
    self.fileNameLabel.hidden = false;
    [self.fileNameLabel setText:fileMsg.fileName];
    [self.fileNameLabel setText:fileMsg.fileName];
    if([self fileisExit:fileMsg.fileLocalPath]){
        if(message.receiptStatus == ZIMMessageReceiptStatusProcessing){
            [self.downLoadButton setImage:[UIImage imageNamed:@"duigou"] forState:UIControlStateNormal];
            self.downLoadButton.hidden = false;
        }else if(message.receiptStatus == ZIMMessageReceiptStatusDone){
            [self.downLoadButton setImage:[UIImage imageNamed:@"duigou-xuanzhong"] forState:UIControlStateNormal];
            self.downLoadButton.hidden = false;
        }else{
            self.downLoadButton.hidden = true;
        }
    }else{
        self.downLoadButton.hidden = false;
    }
}

-(BOOL)fileisExit:(NSString *)
filepath{
    
    NSFileManager *fileManager = [NSFileManager defaultManager];
    if ([fileManager fileExistsAtPath:filepath]) {
        return true;
    } else{
        return false;
    };
}
@end
