//
//  PeerReceiveImageMessageTableViewCell.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/4/29.
//

#import "PeerReceiveImageMessageTableViewCell.h"
#import "ZGZIMManager.h"
@implementation PeerReceiveImageMessageTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

-(void)readyToShow:(ZIMMessage *)message
          callback:(void(^)(MessageCellEvent event,ZIMMessage * msg))callback{
    self.message = message;
    self.readayToShowCallback = callback;
    if(message.receiptStatus == ZIMMessageReceiptStatusProcessing){
        [self.msgStatusImageView setImage:[UIImage imageNamed:@"duigou"]];
        self.msgStatusImageView.hidden = false;
    }else if(message.receiptStatus == ZIMMessageReceiptStatusDone){
        [self.msgStatusImageView setImage:[UIImage imageNamed:@"duigou-xuanzhong"]];
        self.msgStatusImageView.hidden = false;
    }else{
        self.msgStatusImageView.hidden = true;
    }
    ZIMImageMessage *imgMsg = (ZIMImageMessage *)message;
    NSData *imageData = [NSData dataWithContentsOfFile:imgMsg.fileLocalPath];
    if(imageData == nil){
        imageData = [NSData dataWithContentsOfFile:imgMsg.thumbnailLocalPath];
    }
    self.progressView.hidden = true;
    if(imageData == nil){
        [self.photoImageView setImage:[UIImage imageNamed:@"photo"]];
        [[ZGZIMManager shared] downloadMediaFileWithMessage:imgMsg fileType:ZIMMediaFileTypeThumbnail progress:^(ZIMMessage * _Nonnull message, unsigned long long currentFileSize, unsigned long long totalFileSize) {
            self.progressView.hidden = false;
            float progress = [NSString stringWithFormat:@"%.1f",(float)currentFileSize/(float)totalFileSize].floatValue;
            [self.progressView setProgress:progress animated:YES];
        } callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
            self.progressView.hidden = true;
            callback(Update,message);
            if(errorInfo.code == 0){
                NSData *data = [NSData dataWithContentsOfFile:((ZIMImageMessage *)message).thumbnailLocalPath];
                if(data != nil){
                    [self.photoImageView setImage:[UIImage imageWithData:data]];
                }
            }else{
                self.msgStatusImageView.hidden = false;
            }
        }];
    }
    if(imageData != nil){
        [self.photoImageView setImage:[UIImage imageWithData:imageData]];
    }
    
}


@end
