//
//  PeerSendImageMessageTableViewCell.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/4/29.
//

#import "PeerSendImageMessageTableViewCell.h"
#import "ZGZIMManager.h"
@implementation PeerSendImageMessageTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

-(void)readyToShow:(ZIMMessage *)message
          callback:(void(^)(MessageCellEvent event,ZIMMessage * msg))callback{
    self.message = message;
    self.readayToShowCallback = callback;
    ZIMImageMessage *imgMsg = (ZIMImageMessage *)message;
    self.progressView.hidden = true;
    [self.photoView setImage:[UIImage imageWithData:[NSData dataWithContentsOfFile:imgMsg.fileLocalPath]]];
    self.sendConfig.pushConfig = [[ZIMPushConfig alloc] init];
    self.sendConfig.pushConfig.title = @"510";
    self.sendConfig.pushConfig.content = @"111";
    if(imgMsg.sentStatus == 3){
        [imgMsg setValue:[NSNumber numberWithInt:0] forKey:@"sentStatus"];
        self.msgStatusImageView.hidden = true;
        [[ZGZIMManager shared] sendMediaMessage:imgMsg toConversationID:self.masterVC.toUserID conversationType:ZIMConversationTypePeer config:self.sendConfig progress:^(ZIMMessage * _Nonnull message, unsigned long long currentFileSize, unsigned long long totalFileSize) {
            self.progressView.hidden = false;
            float progress = [NSString stringWithFormat:@"%.1f",(float)currentFileSize/(float)totalFileSize].floatValue;
            [self.progressView setProgress:progress animated:YES];
        } callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
            callback(Update,message);

            self.progressView.hidden = true;
            if(errorInfo.code == 0){
                self.msgStatusImageView.hidden = true;
            }else{
                self.msgStatusImageView.hidden = false;
            }
        }];
        callback(Update,imgMsg);
    }
    if(imgMsg.sentStatus == ZIMMessageSentStatusSending){
        self.msgStatusImageView.hidden = true;
       // self.progressView.hidden = true;
    }
    else if(imgMsg.sentStatus == ZIMMessageSentStatusSendSuccess){
        if(imgMsg.receiptStatus == ZIMMessageReceiptStatusProcessing){
            [self.msgStatusImageView setImage:[UIImage imageNamed:@"duigou"]];
            self.msgStatusImageView.hidden = false;
        }else if(imgMsg.receiptStatus == ZIMMessageReceiptStatusDone){
            [self.msgStatusImageView setImage:[UIImage imageNamed:@"duigou-xuanzhong"]];
            self.msgStatusImageView.hidden = false;
        }else{
            self.msgStatusImageView.hidden = true;
        }
        NSData *imageData = [NSData dataWithContentsOfFile:imgMsg.fileLocalPath];
        if(imageData == nil){
            imageData = [NSData dataWithContentsOfFile:imgMsg.largeImageLocalPath];
        }
        if(imageData == nil){
            imageData = [NSData dataWithContentsOfFile:imgMsg.thumbnailLocalPath];
        }
        if(imageData == nil){
            
            [self.photoView setImage:[UIImage imageNamed:@"photo"]];
            [[ZGZIMManager shared] downloadMediaFileWithMessage:imgMsg fileType:ZIMMediaFileTypeThumbnail progress:^(ZIMMessage * _Nonnull message, unsigned long long currentFileSize, unsigned long long totalFileSize) {
                self.progressView.hidden = false;
                float progress = [NSString stringWithFormat:@"%.1f",(float)currentFileSize/(float)totalFileSize].floatValue;
                [self.progressView setProgress:progress animated:YES];
            } callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
                if(errorInfo.code == 0){
                    self.progressView.hidden = true;
                    NSData *data = [NSData dataWithContentsOfFile:((ZIMImageMessage *)message).thumbnailLocalPath];
                    if(data != nil){
                        [self.photoView setImage:[UIImage imageWithData:data]];
                    }
                }
            }];
        }
        if(imageData != nil){
            [self.photoView setImage:[UIImage imageWithData:imageData]];
        }
    }
    else{
        self.msgStatusImageView.hidden = false;
        NSData *imageData = [NSData dataWithContentsOfFile:imgMsg.fileLocalPath];
        if(imageData == nil){
            imageData = [NSData dataWithContentsOfFile:imgMsg.largeImageLocalPath];
        }
        if(imageData == nil){
            imageData = [NSData dataWithContentsOfFile:imgMsg.thumbnailLocalPath];
        }
        if(imageData != nil){
            [self.photoView setImage:[UIImage imageWithData:imageData]];
        }
    }
}



@end
