//
//  PeerSendVideoMessageTableViewCell.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/4/29.
//

#import "PeerSendVideoMessageTableViewCell.h"
#import "ZGZIMManager.h"
#import <AVKit/AVKit.h>
@interface PeerSendVideoMessageTableViewCell()

@property NSURL *sourceUrl;

@end

@implementation PeerSendVideoMessageTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

- (IBAction)playButtonClicked:(UIButton *)sender {
    [_masterVC playSelectVideo:self.sourceUrl];
    
}

-(void)readyToShow:(ZIMMessage *)message
          callback:(void(^)(MessageCellEvent event,ZIMMessage * msg))callback{
    switch (message.sentStatus) {
        case ZIMMessageSentStatusSendFailed:
            [self.msgStatusImageView setImage:[UIImage imageNamed:@"gantanhao-2"]];
            self.msgStatusImageView.hidden = false;
            break;
        case ZIMMessageSentStatusSending:{
            self.msgStatusImageView.hidden = true;
            break;
        }

        case ZIMMessageSentStatusSendSuccess:{
            if(message.receiptStatus == ZIMMessageReceiptStatusProcessing){
                [self.msgStatusImageView setImage:[UIImage imageNamed:@"duigou"]];
                self.msgStatusImageView.hidden = false;
            }else if(message.receiptStatus == ZIMMessageReceiptStatusDone){
                [self.msgStatusImageView setImage:[UIImage imageNamed:@"duigou-xuanzhong"]];
                self.msgStatusImageView.hidden = false;
            }else{
                self.msgStatusImageView.hidden = true;
            }
            break;
        }
        default:
            break;
    }
    self.message = message;
    self.readayToShowCallback = callback;
    ZIMVideoMessage *videoMsg = (ZIMVideoMessage *)message;
    if(videoMsg.sentStatus == 3){
        self.sourceUrl = [NSURL fileURLWithPath:videoMsg.fileLocalPath];
        [self.videoPhotoView setImage:[self cutOutVideo:[NSURL fileURLWithPath:videoMsg.fileLocalPath]]];
        [videoMsg setValue:[NSNumber numberWithInt:0] forKey:@"sentStatus"];
        [[ZGZIMManager shared] sendMediaMessage:videoMsg toConversationID:self.masterVC.toUserID conversationType:ZIMConversationTypePeer config:self.sendConfig progress:^(ZIMMessage * _Nonnull message, unsigned long long currentFileSize, unsigned long long totalFileSize) {
            self.progressView.hidden = false;
            float progress = [NSString stringWithFormat:@"%.1f",(float)currentFileSize/(float)totalFileSize].floatValue;
            [self.progressView setProgress:progress animated:YES];
        } callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
            self.progressView.hidden = true;
            callback(Update,message);
        }];
        callback(Update,videoMsg);
    }
    else if(videoMsg.sentStatus == ZIMMessageSentStatusSending){
        [self.videoPhotoView setImage:[self cutOutVideo:[NSURL fileURLWithPath:videoMsg.fileLocalPath]]];
    }
    else{
        if([videoMsg.fileLocalPath isEqual:@""]){
            [[ZGZIMManager shared] downloadMediaFileWithMessage:videoMsg fileType:ZIMMediaFileTypeOriginalFile progress:^(ZIMMessage * _Nonnull message, unsigned long long currentFileSize, unsigned long long totalFileSize) {
                
            } callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
                if(errorInfo.code == 0){
                    
                    
                    self.sourceUrl = [NSURL fileURLWithPath:((ZIMVideoMessage *)message).fileLocalPath];
                    
                    [self.videoPhotoView setImage:[self cutOutVideo:self.sourceUrl]];
                }
            }];
        }else{
            self.sourceUrl = [NSURL fileURLWithPath:videoMsg.fileLocalPath];
            [self.videoPhotoView setImage:[self cutOutVideo:[NSURL fileURLWithPath:videoMsg.fileLocalPath]]];
        }
        
    }
}


-(UIImage *)cutOutVideo:(NSURL *)sourceUrl{
    AVURLAsset *urlSet = [AVURLAsset assetWithURL:sourceUrl];
        AVAssetImageGenerator *imageGenerator = [AVAssetImageGenerator assetImageGeneratorWithAsset:urlSet];
    imageGenerator.appliesPreferredTrackTransform = YES;
        NSError *error = nil;
        CMTime time = CMTimeMake(0,1);//缩略图创建时间 CMTime是表示电影时间信息的结构体，第一个参数表示是视频第几秒，第二个参数表示每秒帧数.(如果要活的某一秒的第几帧可以使用CMTimeMake方法)
        CMTime actucalTime; //缩略图实际生成的时间
        CGImageRef cgImage = [imageGenerator copyCGImageAtTime:time actualTime:&actucalTime error:&error];
        if (error) {
            NSLog(@"截取视频图片失败:%@",error.localizedDescription);
        }
        CMTimeShow(actucalTime);
    return [UIImage imageWithCGImage:cgImage];
}

@end
