//
//  CreateRoomViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/2/21.
//

#import "CreateRoomViewController.h"
#import "ZGZIMManager.h"
#import "RoomChatViewController.h"
#import "ConversationListDataSource.h"
#import "ZGHUDHelper.h"
@interface CreateRoomViewController ()
@property (weak, nonatomic) IBOutlet UITextField *RoomIDTextField;
@property (weak, nonatomic) IBOutlet UITextField *RoomNameTextField;
@property (weak, nonatomic) IBOutlet UIButton *createButton;

@end

@implementation CreateRoomViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self.createButton setTitle:NSLocalizedString(@"create",nil) forState:UIControlStateNormal];
}
- (IBAction)CreateRoomButtonClicked:(UIButton *)sender {
    if(self.RoomIDTextField.text == nil ||[self.RoomIDTextField.text isEqual:@""]){
        [ZGHUDHelper showMessage:@"room id can not be empty."];
        return;
    }
    ZIMRoomInfo *info = [[ZIMRoomInfo alloc] init];
    info.roomID = self.RoomIDTextField.text;
    info.roomName = self.RoomNameTextField.text;
    
    
    
    [[ZGZIMManager shared] createRoom:info callback:^(ZIMRoomFullInfo * _Nonnull roomInfo, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            RoomChatViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"RoomChatViewController"];
            vc.myRoomID = roomInfo.baseInfo.roomID;
            vc.isRoomOwner = true;
            [self.navigationController pushViewController:vc animated:YES];
            NSMutableArray *marr = [[NSMutableArray alloc]initWithArray:self.navigationController.viewControllers];
            for (UIViewController *vc in marr) {
                if (vc == self) {
                    [marr removeObject:vc];
                    break;          //break一定要加，不加有时候有bug
                }
            }
            self.navigationController.viewControllers = marr;
        }else{
            [ZGHUDHelper showMessage:[NSString stringWithFormat:@"create Room failed! errorcode:%d,error message:%@",(int)errorInfo.code,errorInfo.message]];
        }
    }];
}
- (IBAction)backButtonClicked:(UIButton *)sender {
    UITabBarController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"TabBarViewController"];
    CATransition *animation = [CATransition animation];
    animation.duration = 0.15f;
    animation.type = kCATransitionPush;
    animation.removedOnCompletion = YES;
    animation.subtype = kCATransitionFromLeft;
    [self.view.window.layer addAnimation:animation forKey:nil];
    [self.view.window setRootViewController:vc];
    [[ConversationListDataSource shared] queryMoreConversationList];
}


@end
