//
//  JoinRoomViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/2/21.
//

#import "JoinRoomViewController.h"
#import "ZGZIMManager.h"
#import "RoomChatViewController.h"
#import "ZGHUDHelper.h"
#import "ConversationListDataSource.h"
@interface JoinRoomViewController ()
@property (weak, nonatomic) IBOutlet UITextField *roomIDTextField;
@property (weak, nonatomic) IBOutlet UIButton *joinButton;

@end

@implementation JoinRoomViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self.joinButton setTitle:NSLocalizedString(@"join", nil) forState:UIControlStateNormal];
}
- (IBAction)joinRoomButtonClicked:(UIButton *)sender {
    if(_roomIDTextField.text == nil || [_roomIDTextField.text isEqual:@""]){
        [ZGHUDHelper showMessage:@"room id can not be empty."];
        return;
    }
    [[ZGZIMManager shared] joinRoom:_roomIDTextField.text callback:^(ZIMRoomFullInfo * _Nonnull roomInfo, ZIMError * _Nonnull errorInfo) {
        [ZGHUDHelper hideNetworkLoading];
        if(errorInfo.code == 0){
            RoomChatViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"RoomChatViewController"];
            vc.myRoomID = roomInfo.baseInfo.roomID;
            vc.isRoomOwner = false;
            [self.navigationController pushViewController:vc animated:YES];
        }else{
            [ZGHUDHelper showMessage:[NSString stringWithFormat:@"join room failed!,error code:%d,error message:%@",(int)errorInfo.code,errorInfo.message]];
        }
    }];
    [ZGHUDHelper showNetworkLoading];
}
- (IBAction)backButtonClicked:(UIButton *)sender {
    UITabBarController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"TabBarViewController"];
    CATransition *animation = [CATransition animation];
    animation.duration = 0.15f;
    animation.type = kCATransitionPush;
    animation.removedOnCompletion = YES;
    animation.subtype = kCATransitionFromLeft;
    [self.view.window.layer addAnimation:animation forKey:nil];
    [self.view.window setRootViewController:vc];
    [[ConversationListDataSource shared] queryMoreConversationList];
}



@end
