//
//  RoomChatViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/2/21.
//

#import "RoomChatViewController.h"
#import "RoomChatSendMsgTableViewCell.h"
#import "RoomChatReceiveMsgTableViewCell.h"
#import "RoomMemberListViewController.h"
#import "ZGHUDHelper.h"
#import "RoomNoticeViewController.h"
#import <AVFoundation/AVFoundation.h>
#import <AVKit/AVKit.h>
#import "KeyCenter.h"
#import "RoomSendImageMessageTableViewCell.h"
#import "RoomReceiveImageMessageTableViewCell.h"
#import "RoomSendVideoMessageTableViewCell.h"
#import "RoomReceiveVideoTableViewCell.h"
#import "RoomSendFileMessageTableViewCell.h"
#import "RoomReceiveFileMessageTableViewCell.h"
#import "SelectCallMembersViewController.h"
#import "RevokeMsgTableViewCell.h"
#import "GroupChatSetView.h"
@interface RoomChatViewController ()<ZIMEventDelegate>
@property (weak, nonatomic) IBOutlet UITextView *msgContentTextView;
@property (weak, nonatomic) IBOutlet UITableView *msgTableView;

@property (weak, nonatomic) IBOutlet UIView *nowChatView;
@property UIView *chatSetView;

@property UIView *chatMainView;
//1为收，2为发
@property NSMutableArray *msgTypeList;
@property NSMutableArray<ZIMMessage *> * _Nonnull historyMessageList;

@property NSString *filePath;

@property NSString *imagePath;
@property (weak, nonatomic) IBOutlet UIButton *sendButton;

@property BOOL isCmd;

@end

@implementation RoomChatViewController


- (void)willMoveToParentViewController:(UIViewController*)parent{
    [super willMoveToParentViewController:parent];
    if(parent == nil){
        [[ZGZIMManager shared] removeZIMEventDelegate:self];
        [[ZGZIMManager shared] leaveRoom:self.myRoomID callback:^(NSString * _Nonnull roomID, ZIMError * _Nonnull errorInfo) {}];
    }

}


- (void)viewDidLoad {
    [super viewDidLoad];
    self.navigationItem.title = self.myRoomID;
    UIBarButtonItem *roomAttributesItem = [[UIBarButtonItem alloc] initWithImage:[UIImage imageNamed:@"gonggao-5"] style:UIBarButtonItemStyleDone target:self action:@selector(RoomAttributesButtonClicked)];
    UIBarButtonItem *roomMemberItem = [[UIBarButtonItem alloc] initWithImage:[UIImage imageNamed:@"shezhi-2"] style:UIBarButtonItemStyleDone target:self action:@selector(memberListButtonClicked)];
    self.navigationItem.rightBarButtonItems = @[roomMemberItem,roomAttributesItem];
    [[ZGZIMManager shared] addZIMEventDelegate:self];
    
    [[ZIM getInstance] queryRoomMembersByUserIDs:@[@"51011"] roomID:@"0001" callback:^(NSString * _Nonnull roomID, NSArray<ZIMRoomMemberInfo *> * _Nonnull memberList, NSArray<ZIMErrorUserInfo *> * _Nonnull errorUserList, ZIMError * _Nonnull errorInfo) {
        NSLog(@"510111");
    }];
    self.msgContentTextView.layer.borderWidth = 1;
    [self initMsgDataSource];
    [self clearUnreadMessage];
    [self.sendButton setTitle:NSLocalizedString(@"send", nil) forState:UIControlStateNormal];
    
//    UILongPressGestureRecognizer *gesture = [[UILongPressGestureRecognizer alloc]  initWithTarget:self action:@selector(didLongPressTableViewCell:)];
//    gesture.minimumPressDuration = 1.0;
//    [self.msgTableView addGestureRecognizer:gesture];
}


-(void)clearUnreadMessage{
    [[ZGZIMManager shared] clearConversationUnreadMessageCount:self.myRoomID type:1 callback:^(NSString * _Nonnull conversationID, ZIMConversationType conversationType, ZIMError * _Nonnull errorInfo) {
    }];
}
//MARK: -operation msg data
-(void)initMsgDataSource{
    self.historyMessageList = [[NSMutableArray alloc] init];
    //[self.msgTableView reloadData];
}
//MARK: -ButtonClicked
- (IBAction)sendRoomMessageButtonClicked:(UIButton *)sender {
    if(_isCmd == false){
        ZIMTextMessage *txtMsg = [[ZIMTextMessage alloc] initWithMessage:self.msgContentTextView.text];
        ZIMMessageSendConfig *sendConfig = [[ZIMMessageSendConfig alloc] init];
        sendConfig.priority = 1;
        ZIMPushConfig *pushConfig = [[ZIMPushConfig alloc] init];
        pushConfig.title = self.myRoomID;
        pushConfig.content = txtMsg.message;
        pushConfig.resourcesID = KeyCenter.resourceID;
        sendConfig.pushConfig = pushConfig;
        [[ZGZIMManager shared] sendMessage:txtMsg toConversationID:self.myRoomID conversationType:ZIMConversationTypeRoom config:sendConfig notification:nil callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
            [self renewTableView:false];
        }];
        [self.historyMessageList addObject:txtMsg];
        [self renewTableView:false];
    }
    else{
        ZIMCommandMessage *cmdMsg = [[ZIMCommandMessage alloc] initWithMessage:[self.msgContentTextView.text dataUsingEncoding:NSUTF8StringEncoding] ];
        ZIMMessageSendConfig *sendConfig = [[ZIMMessageSendConfig alloc] init];
        sendConfig.priority = 1;
        [[ZGZIMManager shared] sendMessage:cmdMsg toConversationID:self.myRoomID conversationType:ZIMConversationTypeRoom config:sendConfig notification:nil callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
            [self renewTableView:false];
        }];
        [self.historyMessageList addObject:cmdMsg];
        [self renewTableView:false];
    }
}

- (IBAction)backButtonClicked:(UIButton *)sender {
    
    [self.navigationController popViewControllerAnimated:YES];
    [[ZGZIMManager shared] leaveRoom:self.myRoomID callback:^(NSString * _Nonnull roomID, ZIMError * _Nonnull errorInfo) {}];
}
- (void)memberListButtonClicked {
    RoomMemberListViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"RoomMemberListViewController"];
    vc.myRoomID = self.myRoomID;
    vc.masterVc = self;
    [self.navigationController pushViewController:vc animated:YES];
}
- (void)RoomAttributesButtonClicked{
    if(self.isRoomOwner == true){
        RoomNoticeViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"RoomNoticeViewController"];
        vc.myRoomID = self.myRoomID;
        vc.masterVC = self;
        [self.navigationController pushViewController:vc animated:YES];
    }else{
        [[ZGZIMManager shared] queryRoomAllAttributesByRoomID:self.myRoomID callback:^(NSString * _Nonnull roomID, NSDictionary<NSString *,NSString *> * _Nonnull roomAttributes, ZIMError * _Nonnull errorInfo) {
            if(errorInfo.code == 0){
                NSString *roomBoard = [roomAttributes objectForKey:@"RoomNotice"];
                if([roomBoard isEqual:@""]||roomBoard == nil){
                    [ZGHUDHelper showMessage:NSLocalizedString(@"Room notice is not set.",nil)];
                    return;
                }
                [ZGHUDHelper showMessage:roomBoard];
            }
        }];
    }
    
}

- (IBAction)SwitchCmdButtonClicked:(UIButton *)sender {
    if(_isCmd == false){
        _isCmd = true;
        [sender setImage:[UIImage imageNamed:@"tongzhi"] forState:UIControlStateNormal];
    }else{
        _isCmd = false;
        [sender setImage:[UIImage imageNamed:@"xingzhuang-tuoyuanxing"] forState:UIControlStateNormal];
    }
    
}

-(void)playSelectVideo:(NSURL *)url{
    AVPlayerViewController *playerVc = [[AVPlayerViewController alloc] init];
    AVPlayer *avPlayer= [AVPlayer playerWithURL:url];
    playerVc.player = avPlayer;
    [self presentViewController:playerVc animated:YES completion:nil];
    [playerVc.player play];
}
//MARK: -ZIMEventDelegate
- (void)receiveRoomMessage:(NSArray<ZIMMessage *> *)messageList
                fromRoomID:(NSString *)fromRoomID{
    NSArray *reverseMsgList = [[messageList reverseObjectEnumerator] allObjects];
    
    if(![fromRoomID isEqual:self.myRoomID]) return;
    for (ZIMMessage *message in reverseMsgList) {
    
        [self.historyMessageList addObject:message];
    }
    [self renewTableView:false];
}
//MARK: - TableViewDelegate
- (NSInteger)tableView:(nonnull UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return _historyMessageList.count;
}
- (nonnull UITableViewCell *)tableView:(nonnull UITableView *)tableView cellForRowAtIndexPath:(nonnull NSIndexPath *)indexPath {
    ZIMMessage *msg = _historyMessageList[indexPath.row];
    void(^readayToShowCallback)(MessageCellEvent event,ZIMMessage * msg);
    readayToShowCallback = ^(MessageCellEvent event,ZIMMessage * msg){
        switch (event) {
            case Revoke:{
                [self.historyMessageList replaceObjectAtIndex:indexPath.row withObject:msg];
                break;
            }
            case Delete:{
                [self.historyMessageList removeObject:msg];
                break;
            }
            case Update:{
                [self.historyMessageList replaceObjectAtIndex:indexPath.row withObject:msg];
            }
            default:
                break;
        }
        [tableView reloadData];
    };
    if(msg.direction == ZIMMessageDirectionSend){
        if(msg.type == ZIMMessageTypeText){
            ZIMTextMessage *txtMsg = (ZIMTextMessage *)msg;
            
            RoomChatSendMsgTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RoomChatSendMsgTableViewCell"];
            [cell readyToshow:txtMsg callback:readayToShowCallback];
            return cell;
        }
        else if (msg.type == ZIMMessageTypeImage){
            RoomsendImageMessageTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RoomsendImageMessageTableViewCell"];
            cell.masterVC = (id)self;
            
            [cell readyToShow:(ZIMImageMessage *)msg callback:^(ZIMMessage * _Nonnull imgMsg) {
                [self.historyMessageList replaceObjectAtIndex:indexPath.row withObject:imgMsg];
            }];
            return cell;
        }
        else if (msg.type == ZIMMessageTypeVideo){
            RoomSendVideoMessageTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RoomSendVideoMessageTableViewCell"];
            cell.masterVC = (id)self;
            [cell readyToShow:(ZIMVideoMessage *)msg callback:^(ZIMMessage * _Nonnull videoMsg) {
                [self.historyMessageList replaceObjectAtIndex:indexPath.row withObject:videoMsg];
            }];
            return cell;
        }
        else if (msg.type == ZIMMessageTypeFile){
            RoomSendFileMessageTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RoomSendFileMessageTableViewCell"];
            
            cell.masterVC = (id)self;
            
            [cell readyToShow:(ZIMFileMessage *)msg callback:^(ZIMMessage * _Nonnull fileMsg) {
                [self.historyMessageList replaceObjectAtIndex:indexPath.row withObject:fileMsg];
            }];
            return cell;
        }
        else if(msg.type == ZIMMessageTypeCommand){
            RoomChatSendMsgTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RoomChatSendMsgTableViewCell"];
            [cell.msgLabel setText:@"[cmd message]"];
            [cell.nameLabel setText:[ZGZIMManager shared].myUserID];
            return cell;
        }
        else if(msg.type == ZIMMessageTypeRevoke){
            RevokeMsgTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RevokeMsgTableCell"];
            [cell readyToshow:msg callback:readayToShowCallback];
            return cell;
        }
        else{
            ZIMTextMessage *txtMsg = [[ZIMTextMessage alloc] initWithMessage:@"[未知消息类型]"];
            [txtMsg setValue:[NSNumber numberWithInteger:msg.sentStatus] forKey:@"sentStatus"];
            RoomChatSendMsgTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RoomChatSendMsgTableViewCell"];
            [cell readyToshow:txtMsg callback:readayToShowCallback];
            return cell;
        }
    }
    else if(msg.direction == ZIMMessageDirectionReceive){
        if(msg.type == ZIMMessageTypeText){
            ZIMTextMessage *txtMsg = (ZIMTextMessage *)msg;
            RoomChatReceiveMsgTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RoomChatReceiveMsgTableViewCell"];
            [cell.receiceMsgLabel setText:txtMsg.message];
            [cell.nameLabel setText:txtMsg.senderUserID];
            return cell;
        }
        else if (msg.type == ZIMMessageTypeBarrage){
            ZIMBarrageMessage *brgMsg = (ZIMBarrageMessage *)msg;
            RoomChatReceiveMsgTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RoomChatReceiveMsgTableViewCell"];
            [cell.receiceMsgLabel setText:brgMsg.message];
            [cell.nameLabel setText:brgMsg.senderUserID];
            return cell;
        }
        else if (msg.type == ZIMMessageTypeImage){
            RoomReceiveImageMessageTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RoomReceiveImageMessageTableViewCell"];
            [cell readyToshow:(ZIMImageMessage *)msg callback:^(ZIMMessage * _Nonnull msg) {
                [self.historyMessageList replaceObjectAtIndex:indexPath.row withObject:msg];
            }];
            return cell;
        }
        else if (msg.type == ZIMMessageTypeVideo){
            RoomReceiveVideoTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RoomReceiveVideoTableViewCell"];
            cell.masterVC = (id)self;
            [cell readyToShow:(ZIMVideoMessage *)msg callback:^(ZIMMessage * _Nonnull videoMsg) {
                [self.historyMessageList replaceObjectAtIndex:indexPath.row withObject:msg];
            }];
            return cell;
        }
        else if (msg.type == ZIMMessageTypeAudio){
            RoomReceiveFileMessageTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RoomReceiveFileMessageTableViewCell"];
            [cell.titleLabel setText:msg.senderUserID];
            cell.fileMsg = (ZIMFileMessage *)msg;
            return cell;
        }
        else if (msg.type == ZIMMessageTypeFile){
            RoomReceiveFileMessageTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RoomReceiveFileMessageTableViewCell"];
            [cell.titleLabel setText:msg.senderUserID];
            cell.fileMsg = (ZIMFileMessage *)msg;
            return cell;
        }
        else if (msg.type == ZIMMessageTypeCommand){
            ZIMCommandMessage *cmdMsg = (ZIMCommandMessage *)msg;
            
            RoomChatReceiveMsgTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RoomChatReceiveMsgTableViewCell"];
            [cell.receiceMsgLabel setText:@"[receive a cmd message]"];
            [cell.nameLabel setText:cmdMsg.senderUserID];
            return cell;
        }
        else if(msg.type == ZIMMessageTypeRevoke){
            RevokeMsgTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RevokeMsgTableCell"];
            [cell readyToshow:msg callback:readayToShowCallback];
            return cell;
        }
        else{
            ZIMTextMessage *txtMsg = [[ZIMTextMessage alloc] initWithMessage:@"[未知消息类型]"];
            RoomChatReceiveMsgTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RoomChatReceiveMsgTableViewCell"];
            [cell.receiceMsgLabel setText:txtMsg.message];
            [cell.nameLabel setText:msg.senderUserID];
            return cell;
        }
    }
    else{
        return 0;
    }
}


- (void)didLongPressTableViewCell:(UILongPressGestureRecognizer *)gesture
{
    if (gesture.state == UIGestureRecognizerStateBegan) {
        //获取到点击的位置
        CGPoint point = [gesture locationInView:self.msgTableView];
        
        NSIndexPath *indexPath = [self.msgTableView indexPathForRowAtPoint:point];
        UITableViewCell *cell = [self.msgTableView cellForRowAtIndexPath:indexPath];
        [cell becomeFirstResponder];
        NSValue *pointValue =  [NSValue valueWithCGPoint:point];
        [cell performSelector:@selector(showMessageMenu:) withObject:pointValue];
        if(indexPath == nil) return;
        
        //do something...
    }
}

- (IBAction)chatSetButtonClicked:(UIButton *)sender {
    _chatSetView = [[[UINib nibWithNibName:@"GroupChatSetView" bundle:[NSBundle mainBundle]]
                     instantiateWithOwner:self options:nil] lastObject];
    CGRect rect = _chatSetView.frame;
    rect.size.width = [UIScreen mainScreen].bounds.size.width;
    [_chatSetView setFrame:rect];
    [_chatSetView setTag:1000];
   // ((GroupChatSetView *)_chatSetView).receiptButton.hidden = true;
    _chatMainView = [self.nowChatView.subviews firstObject];
    [self.nowChatView addSubview:_chatSetView];
    
}

- (IBAction)photoButtonClicked:(UIButton *)sender {
    if([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeSavedPhotosAlbum]){

        UIImagePickerController *imagePickerCtrl = [[UIImagePickerController alloc] init];
        imagePickerCtrl.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
        imagePickerCtrl.delegate = (id)self;
        
        //指定媒体类型,图片(@"public.image"),视频(@"public.movie")
        imagePickerCtrl.mediaTypes = @[@"public.image",@"public.movie"];
        [self presentViewController:imagePickerCtrl animated:YES completion:NULL];
    }
}
- (IBAction)folderButtonClicked:(UIButton *)sender {
    NSArray *types = @[@"public.content",@"public.text"];
    UIDocumentPickerViewController *picker = [[UIDocumentPickerViewController alloc] initWithDocumentTypes:types inMode:UIDocumentPickerModeOpen];
    picker.delegate = (id)self;
    [self presentViewController:picker animated:YES completion:nil];
}

- (IBAction)receiptButtonClicked:(UIButton *)sender {
  
}

- (IBAction)callInviteButtonClicked:(UIButton *)sender {
    

    ZIMRoomMemberQueryConfig *queryConfig = [[ZIMRoomMemberQueryConfig alloc] init];
    queryConfig.count = 20;
    [[ZGZIMManager shared] queryRoomMemberListByRoomID:self.myRoomID config:queryConfig callback:^(NSString * _Nonnull roomID, NSArray<ZIMUserInfo *> * _Nonnull memberList, NSString * _Nonnull nextFlag, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            SelectCallMembersViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"SelectCallMembersViewController"];
            
            [self.navigationController pushViewController:vc animated:NO];
            [vc addList:memberList];
        }
    }];

}

-(void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary<NSString *,id> *)info
{
    
    //拿到图片会就销毁之前的控制器
    [picker dismissViewControllerAnimated:YES completion:nil];
    
    if([[info objectForKey:UIImagePickerControllerMediaType] isEqual:@"public.movie"]){
        NSURL *sourceURL = [info objectForKey:UIImagePickerControllerMediaURL];
        
        [[NSFileManager defaultManager] removeItemAtPath:_filePath error:nil];
        [[NSFileManager defaultManager] removeItemAtPath:_imagePath error:nil];
        NSDateFormatter *formater = [[NSDateFormatter alloc] init];
        [formater setDateFormat:@"yy-MM-dd-HH:mm:ss"];

        _filePath = [NSHomeDirectory() stringByAppendingFormat:@"/Documents/%@", [[formater stringFromDate:[NSDate date]] stringByAppendingString:@".mp4"]];


        NSString  *videoPath =  info[UIImagePickerControllerMediaURL];

        NSFileManager *fileManager = [NSFileManager defaultManager];

        NSError *error;
        [fileManager copyItemAtPath:videoPath toPath:_filePath error:&error];
        if (error)
        {

            NSLog(@"文件保存到缓存失败");
        }

        
        [sourceURL startAccessingSecurityScopedResource];
        ZIMVideoMessage *videoMsg = [[ZIMVideoMessage alloc] initWithFileLocalPath:_filePath videoDuration:10];
        [videoMsg setValue:[ZGZIMManager shared].myUserID forKey:@"senderUserID"];
        [videoMsg setValue:[NSNumber numberWithInt:3] forKey:@"sentStatus"];
        [self.historyMessageList addObject:videoMsg];
        [self renewTableView:false];

    }else if ([[info objectForKey:UIImagePickerControllerMediaType] isEqual:@"public.image"]){
//        info中就是包含你在相册里面选择的图片(info字典里面还有图片的url-有需要的可以将info打印出来取自己要的数据)
        NSURL *url = [info objectForKey:@"UIImagePickerControllerImageURL"];
        
        NSString *urlStr = url.path;
        ZIMImageMessage *message = [[ZIMImageMessage alloc] initWithFileLocalPath:urlStr];
        [message setValue:[ZGZIMManager shared].myUserID forKey:@"senderUserID"];
        [message setValue:[NSNumber numberWithInt:3] forKey:@"sentStatus"];
        [self.historyMessageList addObject:message];
        [self renewTableView:false];
    }
}

- (void)documentPicker:(UIDocumentPickerViewController *)controller didPickDocumentsAtURLs:(NSArray<NSURL *> *)urls {
    // 获取授权
    [urls.firstObject startAccessingSecurityScopedResource];
    
    ZIMFileMessage *fileMsg = [[ZIMFileMessage alloc] initWithFileLocalPath:[urls firstObject].path];
    ZIMMessageSendConfig *sendConfig = [[ZIMMessageSendConfig alloc] init];
    sendConfig.priority = 1;
    [fileMsg setValue:[NSNumber numberWithInt:3] forKey:@"sentStatus"];
    [self.historyMessageList addObject:fileMsg];
    [self renewTableView:false];
}


-(void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
    if([touches anyObject].view.tag != 1000){
        NSLog(@"点击到外部");
        [_chatSetView removeFromSuperview];
        [self.nowChatView addSubview:_chatMainView];
    }else{
        NSLog(@"点击到内部");
    }
    
}


-(void)renewTableView:(BOOL)isTop{
    [self.msgTableView reloadData];
    dispatch_async(dispatch_get_main_queue(), ^{
        if(isTop == false){
            if(self.historyMessageList.count>0){
                [self.msgTableView scrollToRowAtIndexPath:[NSIndexPath indexPathForRow:self.historyMessageList.count -1 inSection:0]  atScrollPosition:UITableViewScrollPositionBottom animated:YES];
            }
        }else{
            
        }
    });
    
    
}

- (void)roomStateChanged:(ZIMRoomState)state
               event:(ZIMRoomEvent)event
        extendedData:(NSDictionary *)extendedData
                  roomID:(NSString *)roomID{
    if(![roomID isEqual: self.myRoomID]){
        return;
    }
    if(event == ZIMRoomEventRoomNotExist){
        UITabBarController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"TabBarViewController"];
        [self.view.window setRootViewController:vc];
        [[ZGZIMManager shared] leaveRoom:self.myRoomID callback:^(NSString * _Nonnull roomID, ZIMError * _Nonnull errorInfo) {}];
        [ZGHUDHelper showMessage:@"room is not exit"];
    }
}

//

@end
