//
//  RoomReceiveImageMessageTableViewCell.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/4/29.
//

#import "RoomReceiveImageMessageTableViewCell.h"
#import "ZGZIMManager.h"
@implementation RoomReceiveImageMessageTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];
}

-(void)readyToshow:(ZIMImageMessage *)imgMsg
          callback:(void(^)(ZIMMessage * msg))callbackMsg{
    [self.titleLabel setText:imgMsg.senderUserID];
    NSData *imageData = [NSData dataWithContentsOfFile:imgMsg.fileLocalPath];
    if(imageData == nil){
        imageData = [NSData dataWithContentsOfFile:imgMsg.thumbnailLocalPath];
    }
    if(imageData == nil){
        [[ZGZIMManager shared] downloadMediaFileWithMessage:imgMsg fileType:ZIMMediaFileTypeThumbnail progress:^(ZIMMessage * _Nonnull message, unsigned long long currentFileSize, unsigned long long totalFileSize) {
            self.progress.hidden = false;
            float progress = [NSString stringWithFormat:@"%.1f",(float)currentFileSize/(float)totalFileSize].floatValue;
            [self.progress setProgress:progress animated:YES];
        } callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
            self.progress.hidden = true;
            if(errorInfo.code == 0){
                NSData *data = [NSData dataWithContentsOfFile:((ZIMImageMessage *)message).thumbnailLocalPath];
                if(data != nil){
                    [self.photoView setImage:[UIImage imageWithData:data]];
                }
                callbackMsg(message);
            }
        }];
        self.progress.progress = 0.0;
        [self.photoView setImage:[UIImage imageNamed:@"photo"]];
    }
    if(imageData != nil){
        [self.photoView setImage:[UIImage imageWithData:imageData]];
    }
}

@end
