//
//  RoomReceiveVideoTableViewCell.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/4/29.
//

#import "RoomReceiveVideoTableViewCell.h"
#import <AVKit/AVKit.h>
@interface RoomReceiveVideoTableViewCell()

@property NSURL *sourceUrl;

@end

@implementation RoomReceiveVideoTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}
- (IBAction)playButtonClicked:(UIButton *)sender {
    [_masterVC playSelectVideo:self.sourceUrl];
}

-(void)readyToShow:(ZIMVideoMessage *)videoMsg
          callback:(void(^)(ZIMMessage * videoMsg))callbackMsg{
    [self.titleLabel setText:[ZGZIMManager shared].myUserID];
    
    [[ZGZIMManager shared] downloadMediaFileWithMessage:videoMsg fileType:ZIMMediaFileTypeOriginalFile progress:^(ZIMMessage * _Nonnull message, unsigned long long currentFileSize, unsigned long long totalFileSize) {
        
    } callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            
            
            self.sourceUrl = [NSURL fileURLWithPath:((ZIMVideoMessage *)message).fileLocalPath];
            
            [self.photoView setImage:[self cutOutVideo:self.sourceUrl]];
            callbackMsg(message);
        }
    }];
    
}

-(UIImage *)cutOutVideo:(NSURL *)sourceUrl{
    AVURLAsset *urlSet = [AVURLAsset assetWithURL:sourceUrl];
        AVAssetImageGenerator *imageGenerator = [AVAssetImageGenerator assetImageGeneratorWithAsset:urlSet];
    imageGenerator.appliesPreferredTrackTransform = YES;
        NSError *error = nil;
        CMTime time = CMTimeMake(0,1);//缩略图创建时间 CMTime是表示电影时间信息的结构体，第一个参数表示是视频第几秒，第二个参数表示每秒帧数.(如果要活的某一秒的第几帧可以使用CMTimeMake方法)
        CMTime actucalTime; //缩略图实际生成的时间
        CGImageRef cgImage = [imageGenerator copyCGImageAtTime:time actualTime:&actucalTime error:&error];
        if (error) {
            NSLog(@"截取视频图片失败:%@",error.localizedDescription);
        }
        CMTimeShow(actucalTime);
    return [UIImage imageWithCGImage:cgImage];
}
@end
