//
//  RoomSendVideoMessageTableViewCell.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/4/29.
//

#import "RoomSendVideoMessageTableViewCell.h"

#import <AVKit/AVKit.h>
@interface RoomSendVideoMessageTableViewCell()

@property NSURL *sourceUrl;

@end

@implementation RoomSendVideoMessageTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

-(void)readyToShow:(ZIMVideoMessage *)videoMsg
          callback:(void(^)(ZIMMessage * videoMsg))callbackMsg{
    [self.titleLabel setText:[ZGZIMManager shared].myUserID];
    if(videoMsg.sentStatus == 3){
        self.sourceUrl = [NSURL fileURLWithPath:videoMsg.fileLocalPath];
        
        ZIMMessageSendConfig *sendConfig = [[ZIMMessageSendConfig alloc] init];
        sendConfig.priority = 1;
        [self.photoView setImage:[self cutOutVideo:[NSURL fileURLWithPath:videoMsg.fileLocalPath]]];
        [videoMsg setValue:[NSNumber numberWithInt:0] forKey:@"sentStatus"];
        [[ZGZIMManager shared] sendMediaMessage:videoMsg toConversationID:self.masterVC.myRoomID conversationType:ZIMConversationTypeRoom config:sendConfig progress:^(ZIMMessage * _Nonnull message, unsigned long long currentFileSize, unsigned long long totalFileSize) {
            self.progressView.hidden = false;
            float progress = [NSString stringWithFormat:@"%.1f",(float)currentFileSize/(float)totalFileSize].floatValue;
            [self.progressView setProgress:progress animated:YES];
        } callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
            self.progressView.hidden = true;
            callbackMsg(message);
        }];
        callbackMsg(videoMsg);
    }
    if(videoMsg.sentStatus == ZIMMessageSentStatusSending){
        [self.photoView setImage:[self cutOutVideo:[NSURL fileURLWithPath:videoMsg.fileLocalPath]]];
    }
    else{
        if([videoMsg.fileLocalPath isEqual:@""]){
            [[ZGZIMManager shared] downloadMediaFileWithMessage:videoMsg fileType:ZIMMediaFileTypeOriginalFile progress:^(ZIMMessage * _Nonnull message, unsigned long long currentFileSize, unsigned long long totalFileSize) {
                
            } callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
                if(errorInfo.code == 0){
                    
                    
                    self.sourceUrl = [NSURL fileURLWithPath:((ZIMVideoMessage *)message).fileLocalPath];
                    
                    [self.photoView setImage:[self cutOutVideo:self.sourceUrl]];
                }
            }];
        }else{
            self.sourceUrl = [NSURL fileURLWithPath:videoMsg.fileLocalPath];
            
            [self.photoView setImage:[self cutOutVideo:self.sourceUrl]];
        }
        
    }
}

- (IBAction)playButtonClicked:(UIButton *)sender {
    [self.masterVC playSelectVideo:self.sourceUrl];
    
}

-(UIImage *)cutOutVideo:(NSURL *)sourceUrl{
    AVURLAsset *urlSet = [AVURLAsset assetWithURL:sourceUrl];
        AVAssetImageGenerator *imageGenerator = [AVAssetImageGenerator assetImageGeneratorWithAsset:urlSet];
    imageGenerator.appliesPreferredTrackTransform = YES;
        NSError *error = nil;
        CMTime time = CMTimeMake(0,1);//缩略图创建时间 CMTime是表示电影时间信息的结构体，第一个参数表示是视频第几秒，第二个参数表示每秒帧数.(如果要活的某一秒的第几帧可以使用CMTimeMake方法)
        CMTime actucalTime; //缩略图实际生成的时间
        CGImageRef cgImage = [imageGenerator copyCGImageAtTime:time actualTime:&actucalTime error:&error];
        if (error) {
            NSLog(@"截取视频图片失败:%@",error.localizedDescription);
        }
        CMTimeShow(actucalTime);
    return [UIImage imageWithCGImage:cgImage];
}

@end
