//
//  RoomsendImageMessageTableViewCell.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/4/29.
//

#import "RoomsendImageMessageTableViewCell.h"
#import "ZGZIMManager.h"
@implementation RoomsendImageMessageTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}


-(void)readyToShow:(ZIMImageMessage *)imgMsg
          callback:(void(^)(ZIMMessage * imgMsg))callbackMsg{
    self.downloadErrorImageView.hidden = true;
    self.titleLabel.text = imgMsg.senderUserID;
    if(imgMsg.sentStatus == 3){
        ZIMMessageSendConfig *sendConfig = [[ZIMMessageSendConfig alloc] init];
        sendConfig.priority = 1;
        [self.photoView setImage:[UIImage imageWithData:[NSData dataWithContentsOfFile:imgMsg.fileLocalPath]]];
        [imgMsg setValue:[NSNumber numberWithInt:0] forKey:@"sentStatus"];
        [[ZGZIMManager shared] sendMediaMessage:imgMsg toConversationID:self.masterVC.myRoomID conversationType:ZIMConversationTypeRoom config:sendConfig progress:^(ZIMMessage * _Nonnull message, unsigned long long currentFileSize, unsigned long long totalFileSize) {
            self.progressView.hidden = false;
            float progress = [NSString stringWithFormat:@"%.1f",(float)currentFileSize/(float)totalFileSize].floatValue;
            [self.progressView setProgress:progress animated:YES];
        } callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
            self.progressView.hidden = true;
            callbackMsg(message);
            if(errorInfo.code == 0){
                
            }else{
                self.downloadErrorImageView.hidden = false;
            }
        }];
        callbackMsg(imgMsg);
    }
    else if(imgMsg.sentStatus == ZIMMessageSentStatusSending){
        [self.photoView setImage:[UIImage imageWithData:[NSData dataWithContentsOfFile:imgMsg.fileLocalPath]]];
    }
    else{
        if(imgMsg.sentStatus == ZIMMessageSentStatusSendFailed){
            self.downloadErrorImageView.hidden = false;
        }
        
        NSData *imageData = [NSData dataWithContentsOfFile:imgMsg.fileLocalPath];
        if(imageData == nil){
            imageData = [NSData dataWithContentsOfFile:imgMsg.largeImageLocalPath];
        }
        if(imageData == nil){
            imageData = [NSData dataWithContentsOfFile:imgMsg.thumbnailLocalPath];
        }
        if(imageData == nil){
            
            [self.photoView setImage:[UIImage imageNamed:@"photo"]];
            [[ZGZIMManager shared] downloadMediaFileWithMessage:imgMsg fileType:ZIMMediaFileTypeThumbnail progress:^(ZIMMessage * _Nonnull message, unsigned long long currentFileSize, unsigned long long totalFileSize) {
                self.progressView.hidden = false;
                float progress = [NSString stringWithFormat:@"%.1f",(float)currentFileSize/(float)totalFileSize].floatValue;
                [self.progressView setProgress:progress animated:YES];
            } callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
                if(errorInfo.code == 0){
                    self.progressView.hidden = true;
                    NSData *data = [NSData dataWithContentsOfFile:((ZIMImageMessage *)message).thumbnailLocalPath];
                    if(data != nil){
                        [self.photoView setImage:[UIImage imageWithData:data]];
                    }
                }
            }];
        }
        if(imageData != nil){
            [self.photoView setImage:[UIImage imageWithData:imageData]];
        }
    }
}

@end
