//
//  RoomMemberListViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/2/22.
//

#import "RoomMemberListViewController.h"
#import "ZGZIMManager.h"
#import "RoomListTableViewCell.h"
@interface RoomMemberListViewController ()<UITableViewDelegate,UITableViewDataSource>


@property NSMutableArray<ZIMUserInfo *> *userList;
@property (weak, nonatomic) IBOutlet UITableView *userListTabeView;

@end

@implementation RoomMemberListViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self queryMemberList];
    self.navigationItem.title = NSLocalizedString(@"Member List",nil);
}
- (IBAction)backButtonClicked:(id)sender {
    [self.view.window setRootViewController:self.masterVc];
}

-(void)queryMemberList{
    ZIMRoomMemberQueryConfig *config = [[ZIMRoomMemberQueryConfig alloc] init];
    config.count = 1;
    [[ZGZIMManager shared] queryRoomMemberListByRoomID:self.myRoomID config:config callback:^(NSString * _Nonnull roomID, NSArray<ZIMUserInfo *> * _Nonnull memberList, NSString * _Nonnull nextFlag, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            config.nextFlag = nextFlag;
            NSLog(@"[test] %@,nextflag:%@",memberList.firstObject.userID,nextFlag);
            [[ZGZIMManager shared] queryRoomMemberListByRoomID:self.myRoomID config:config callback:^(NSString * _Nonnull roomID, NSArray<ZIMUserInfo *> * _Nonnull memberList, NSString * _Nonnull nextFlag, ZIMError * _Nonnull errorInfo) {
                NSLog(@"[test] %@,nextflag:%@",memberList.firstObject.userID,nextFlag);
            }];
            self.userList = (NSMutableArray *)memberList;
            [self.userListTabeView reloadData];
        }
    }];
}
//MARK: - TableViewDelegate
- (NSInteger)tableView:(nonnull UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return self.userList.count;
}
- (nonnull UITableViewCell *)tableView:(nonnull UITableView *)tableView cellForRowAtIndexPath:(nonnull NSIndexPath *)indexPath {
    RoomListTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RoomListTableViewCell"];
    if([self.userList[indexPath.row].userName isEqual:@""] ||self.userList[indexPath.row].userName == nil){
        cell.nameLabel.text = self.userList[indexPath.row].userID;
    }else{
        cell.nameLabel.text = self.userList[indexPath.row].userName;
    }
           
    return cell;
}

@end
