//
//  RoomNoticeViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/2/24.
//

#import "RoomNoticeViewController.h"
#import "ZGZIMManager.h"
#import "ZGHUDHelper.h"
@interface RoomNoticeViewController ()
@property (weak, nonatomic) IBOutlet UITextView *noticeTextView;
@property (weak, nonatomic) IBOutlet UIButton *okButton;
@end

@implementation RoomNoticeViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.noticeTextView.layer.borderWidth = 1;
    self.navigationItem.title = NSLocalizedString(@"Room Notice",nil);
    [self.okButton setTitle:NSLocalizedString(@"OK", nil) forState:UIControlStateNormal];
}

-(void)queryRoomAttributes{
    [[ZGZIMManager shared] queryRoomAllAttributesByRoomID:self.myRoomID callback:^(NSString * _Nonnull roomID, NSDictionary<NSString *,NSString *> * _Nonnull roomAttributes, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            NSString *roomBoard = [roomAttributes objectForKey:@"Notice"];
            if([roomBoard isEqual:@""]||roomBoard == nil){
                self.noticeTextView.text = @"";
                return;
            }
            self.noticeTextView.text = roomBoard;
        }
    }];
}

- (IBAction)backButtonClicked:(UIButton *)sender {
    [self.view.window setRootViewController:self.masterVC];
}
- (IBAction)confirmButtonClicked:(UIButton *)sender {
    NSDictionary *roomAttributes = @{@"RoomNotice":_noticeTextView.text};
    ZIMRoomAttributesSetConfig *config = [[ZIMRoomAttributesSetConfig alloc] init];
    [[ZGZIMManager shared] setRoomAttributes:roomAttributes roomID:self.myRoomID config:config callback:^(NSString * _Nonnull roomID, NSArray<NSString *> * _Nonnull errorKeys, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            [ZGHUDHelper showMessage:NSLocalizedString(@"Edited successfully.",nil)];
        }
        else{
            
            [ZGHUDHelper showMessage:[NSString stringWithFormat:@"%@error code:%d,error message:%@",NSLocalizedString(@"Failed to edit.",nil),(int)errorInfo.code,errorInfo.message]];
        }
    }];
}

@end
