//
//  StartViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/11/2.
//

#import "StartViewController.h"
#import "LoginViewController.h"
#import <ZIM/ZIM.h>
#import "KeyCenter.h"
#import "ZGZIMManager.h"
#import "ConversationListDataSource.h"
@interface StartViewController ()

@end

@implementation StartViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self.navigationController setNavigationBarHidden:YES];
    [self AutoLogin];

    // Do any additional setup after loading the view.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/
-(void)AutoLogin{
    
    ZIMAppConfig *config = [[ZIMAppConfig alloc] init];
    config.appID = KeyCenter.appID;
    config.appSign = KeyCenter.appSign;
    NSUserDefaults *userDefault = [NSUserDefaults standardUserDefaults];
    NSString *userID = [userDefault objectForKey:@"alreadyUserID"];
    NSString *userName = [userDefault objectForKey:@"alreadyUserName"];
    if(userID != nil && ![userID isEqual:@""]){
        ZIMAppConfig *appConfig = [[ZIMAppConfig alloc] init];
        appConfig.appID = KeyCenter.appID;
        appConfig.appSign = KeyCenter.appSign;
        [[ZGZIMManager shared] createZIM:config];

        ZIMUserInfo *userInfo = [[ZIMUserInfo alloc] init];
        userInfo.userID = userID;
        userInfo.userName = userName;
    
        [[ZGZIMManager shared] login:userInfo token:@"" callback:^(ZIMError * _Nonnull errorInfo) {
            if(errorInfo.code == 0){
                [ZGZIMManager shared].myUserID = userInfo.userID;
                [self loginSuccess];
            }else{
                [self goToLoginView];
            }
        }];

    }else{
        [[ZIM getInstance] destroy];
        [self goToLoginView];
    }
}

-(void)goToLoginView{
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.5 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        LoginViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"LoginViewController"];
        CATransition *tration = [CATransition animation];
         tration.duration = 1.5f;
         tration.type = kCATransitionFade;
         [self.navigationController.view.layer addAnimation:tration forKey:nil];
       // [self.navigationController pushViewController:vc animated:NO];
        NSMutableArray *controllers = [NSMutableArray arrayWithArray:self.navigationController.viewControllers];
        controllers[0] = vc;
        [self.navigationController setViewControllers:controllers];

    });
}

-(void)loginSuccess{
    UITabBarController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"TabBarViewController"];
    [ZGZIMManager shared].myTabbar = (id)vc;
    
    CATransition *tration = [CATransition animation];
     tration.duration = 1.5f;
     tration.type = kCATransitionFade;
     [self.navigationController.view.layer addAnimation:tration forKey:nil];
    NSMutableArray *controllers = [NSMutableArray arrayWithArray:self.navigationController.viewControllers];
    controllers[0] = vc;
    [self.navigationController setViewControllers:controllers];
    [[ConversationListDataSource shared] queryMoreConversationList];
}


@end
