//
//  MyselfViewController.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/6/22.
//

#import "MyselfViewController.h"
#import "ZGZIMManager.h"
#import "ZGHUDHelper.h"
#import "LoginViewController.h"
#import "ConversationListDataSource.h"
#import "HistroyCallUIViewController.h"
@interface MyselfViewController ()

@property (weak, nonatomic) IBOutlet UIView *avatarUIView;
@property (weak, nonatomic) IBOutlet UIView *userNameUIView;
@property (weak, nonatomic) IBOutlet UIView *userIDUIView;
@property (weak, nonatomic) IBOutlet UIView *logoutUIView;


@property ZIMUserFullInfo *userFullInfo;

@property int counter;

@end

@implementation MyselfViewController

-(void)setShadow:(UIView *)targetView{
    targetView.layer.shadowColor = [UIColor grayColor].CGColor;
    targetView.layer.shadowOffset = CGSizeMake(0,0);
    targetView.layer.shadowOpacity = 0.5;
    targetView.layer.shadowRadius = 1;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    [self setShadow:_avatarUIView];
    [self setShadow:_userNameUIView];
    [self setShadow:_userIDUIView];
    [self setShadow:_logoutUIView];
    _counter = 1;
    ZIMUsersInfoQueryConfig *config = [[ZIMUsersInfoQueryConfig alloc] init];
    config.isQueryFromServer = true;
    NSMutableArray *userIDs = [[NSMutableArray alloc] init];
    [userIDs addObject:[ZGZIMManager shared].myUserID];
    [[ZGZIMManager shared] queryUsersInfo:userIDs config:config callback:^(NSArray<ZIMUserFullInfo *> * _Nonnull userList, NSArray<ZIMErrorUserInfo *> * _Nonnull errorUserList, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            
            self.userFullInfo = userList.firstObject;
            [ZGZIMManager shared].userFullInfo = userList.firstObject;
            [self.userName setText:self.userFullInfo.baseInfo.userName];
            [self.userID setText:self.userFullInfo.baseInfo.userID];
 
            if(userList.firstObject != nil){
                if(![userList.firstObject.userAvatarUrl isEqual:@""]){
                    self.avatar.image = [UIImage imageWithData:[NSData dataWithContentsOfURL:[NSURL URLWithString:userList.firstObject.userAvatarUrl]]];

                }
            }
            
        }
    }];
   
    // Do any additional setup after loading the view.
}

- (IBAction)avatarMenderOnTap:(UIButton *)sender {
    if(_counter == 5){
        _counter = 1;
    }else{
    _counter = _counter + 1;
    }
    
    NSString *url = [NSString stringWithFormat:@"https://storage.zego.im/zim/example/web/assets/%d.jpeg",_counter];
    [[ZGZIMManager shared] updateUserAvatarUrl:url callback:^(NSString * _Nonnull userAvatarUrl, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            self.avatar.image = [UIImage imageWithData:[NSData dataWithContentsOfURL:[NSURL URLWithString:url]]];
           // [ZGZIMManager shared].userFullInfo.extendedData = userExtendedData;
        }else{
            [ZGHUDHelper showMessage:[NSString stringWithFormat:@"update avatar error! code: %lu , message: %@",(unsigned long)errorInfo.code,errorInfo.message]];
        }

    }];
//    [[ZGZIMManager shared] updateUserExtendedData:json callback:^(NSString * _Nonnull userExtendedData, ZIMError * _Nonnull errorInfo) {
//        if(errorInfo.code == 0){
//            self.avatar.image = [UIImage imageWithData:[NSData dataWithContentsOfURL:[NSURL URLWithString:url]]];
//            [ZGZIMManager shared].userFullInfo.extendedData = userExtendedData;
//        }else{
//            [ZGHUDHelper showMessage:[NSString stringWithFormat:@"update avatar error! code: %lu , message: %@",errorInfo.code,errorInfo.message]];
//        }
//    }];
    
}
- (IBAction)histroyCallButtonClicked:(UIButton *)sender {
    ZIMCallInvitationQueryConfig *config = [[ZIMCallInvitationQueryConfig alloc] init];
    config.count = 100;
    NSMutableArray<ZIMCallInfo *> *totalCallList = [[NSMutableArray alloc] init];
    ZIMCallInvitationListQueriedCallback __block callback = ^(NSArray<ZIMCallInfo *> * _Nonnull callList, long long nextFlag, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == ZIMErrorCodeSuccess){
            [totalCallList addObjectsFromArray:callList];
            if(nextFlag != 0){
                config.nextFlag = nextFlag;
                [[ZGZIMManager shared] queryCallInvitationListWithConfig:config callback:callback];
            }else{
                HistroyCallUIViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"HistroyCallUIViewController"];
                vc.callInfoList = totalCallList;
                [self.navigationController pushViewController:vc animated:YES];
            }
        }
    };
    [[ZGZIMManager shared] queryCallInvitationListWithConfig:config callback:callback];
}
- (IBAction)logoutButtonClicked:(UIButton *)sender {
    [[ZIM getInstance] logout];
    [self deleteLoggedinCount];
    
    [ConversationListDataSource releaseMySelf];
    LoginViewController *vc = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"LoginViewController"];
    NSMutableArray *controllers = [NSMutableArray arrayWithArray:self.navigationController.viewControllers];
            controllers[0] = vc;
    [ZGHUDHelper showNetworkLoading];
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.3 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [ZGHUDHelper hideNetworkLoading];
        [self.navigationController setViewControllers:controllers];
    });
    [[ZGZIMManager shared] destroyZIM];

    
}
- (IBAction)userNameMenderOnTap:(UIButton *)sender {
    NSLog(@"%@",self.userName.text);
    NSLog(@"%@",[ZGZIMManager shared].userFullInfo.baseInfo.userName);
    if(![self.userName.text isEqual:[ZGZIMManager shared].userFullInfo.baseInfo.userName]){
        [[ZGZIMManager shared] updateUserName:self.userName.text callback:^(NSString * _Nonnull userName, ZIMError * _Nonnull errorInfo) {
            if(errorInfo.code == 0){
                [ZGHUDHelper showMessage:@"success"];
                [ZGZIMManager shared].userFullInfo.baseInfo.userName = userName;
            }else{
                [ZGHUDHelper showMessage:[NSString stringWithFormat:@"update name error! code: %lu , message: %@",errorInfo.code,errorInfo.message]];
            }
        }];
    }
}

-(void)deleteLoggedinCount{
    NSUserDefaults *userDefault = [NSUserDefaults standardUserDefaults];
    [userDefault setObject:@"" forKey:@"alreadyUserID"];
    [userDefault setObject:@"" forKey:@"alreadyUserName"];
  //  NSDate
}

@end
