//
//  MessageTableViewCell.m
//  ZIMExampleDemo
//
//  Created by 武耀琳 on 2022/11/17.
//

#import "MessageTableViewCell.h"
#import "ZGHUDHelper.h"
#import "KeyCenter.h"
@interface MessageTableViewCell ()



@end


@implementation MessageTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

- (BOOL)canBecomeFirstResponder
{
    return YES;
}


- (BOOL)canPerformAction:(SEL)action withSender:(id)sender
{
    if (action == @selector(zhDelete:) || action == @selector(zhCopy:)|| action == @selector(zhRevoke:) || action == @selector(zhReceipt:)) {
        return YES;
    }
    return NO;
}


-(void)zhRevoke:(id)sender
{
    ZIMMessageRevokeConfig *revokeConfig = [[ZIMMessageRevokeConfig alloc] init];
    ZIMPushConfig *pushConfig = [[ZIMPushConfig alloc] init];
    pushConfig.title = [ZGZIMManager shared].myUserID;
    pushConfig.content = @"撤回了一条消息";
    pushConfig.resourcesID = KeyCenter.resourceID;
    revokeConfig.pushConfig = pushConfig;
    [[ZGZIMManager shared] revokeMessage:self.message config:revokeConfig callback:^(ZIMMessage * _Nonnull message, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            if(self.readayToShowCallback != nil){
                self.readayToShowCallback(Revoke, message);
            }
        }else{
            [ZGHUDHelper showMessage:[NSString stringWithFormat:@"revoke failed!,%lu,%@",(unsigned long)errorInfo.code,errorInfo.message]];
        }
    }];
}


-(void)zhCopy:(id)sender
{
    
}

-(void)zhDelete:(id)sender
{
    ZIMMessageDeleteConfig *deleteConfig = [[ZIMMessageDeleteConfig alloc] init];
    deleteConfig.isAlsoDeleteServerMessage = true;
    [[ZGZIMManager shared] deleteMessages:[NSArray arrayWithObjects:_message, nil] conversationID:_message.conversationID conversationType:_message.conversationType config:deleteConfig callback:^(NSString * _Nonnull conversationID, ZIMConversationType conversationType, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            self.readayToShowCallback(Delete,self.message);
        }else{
            UIAlertController *alertView = [UIAlertController alertControllerWithTitle:@"tips" message:@"success" preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction *action = [UIAlertAction actionWithTitle:@"OK" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
                
                
            }];
            [alertView addAction:action];
            [[UIApplication sharedApplication].keyWindow.rootViewController.navigationController pushViewController:alertView animated:YES];
            
        }
    }];
}

-(void)zhReceipt:(id)sender
{
    
    [[ZGZIMManager shared] queryMessageReceiptsInfoByMessageList:@[_message] conversationID:_message.conversationID conversationType:_message.conversationType callback:^(NSArray<ZIMMessageReceiptInfo *> * _Nonnull infos, NSArray<NSString *> * _Nonnull errorMessageIDs, ZIMError * _Nonnull errorInfo) {
        if(errorInfo.code == 0){
            [ZGHUDHelper showMessage:[NSString stringWithFormat:@"read member count:%d,unread member count:%d",infos.firstObject.readMemberCount,infos.firstObject.unreadMemberCount]];
        }
    }];
}

-(void)showMessageMenu:(NSValue *) pointValue{
    UIMenuItem *deleteLink = [[UIMenuItem alloc] initWithTitle:@"删除" action:@selector(zhDelete:)];
    UIMenuItem *copyLink = [[UIMenuItem alloc] initWithTitle:@"复制" action:@selector(zhCopy:)];
    UIMenuItem *revokeLink = [[UIMenuItem alloc] initWithTitle:@"撤回" action:@selector(zhRevoke:)];
    
    if((_message.receiptStatus == ZIMMessageReceiptStatusProcessing ||_message.receiptStatus == ZIMMessageReceiptStatusDone) && _message.conversationType == ZIMConversationTypeGroup){
        UIMenuItem *receiptLink = [[UIMenuItem alloc] initWithTitle:@"查看回执状态" action:@selector(zhReceipt:)];
        [[UIMenuController sharedMenuController] setMenuItems:[NSArray arrayWithObjects:deleteLink,copyLink,revokeLink,receiptLink, nil]];
    }else{
        [[UIMenuController sharedMenuController] setMenuItems:[NSArray arrayWithObjects:deleteLink,copyLink,revokeLink, nil]];
    }
    CGRect myCGRect = CGRectMake(pointValue.CGPointValue.x, pointValue.CGPointValue.y, 0, 0);
    [[UIMenuController sharedMenuController] setTargetRect:myCGRect inView:self.superview];
    [[UIMenuController sharedMenuController] setMenuVisible:YES animated:YES];
    
}

-(void)readyToshow:(ZIMMessage *)message
          callback:(void(^)(MessageCellEvent event,ZIMMessage * msg))callback{
    self.message = message;
    self.readayToShowCallback = callback;
}
@end
